(function (win, doc) {

var
	cfg = widget['preferences'],
	oex = opera['extension'],
	root = doc.documentElement,
	img = doc.querySelector('html:root>body img[src=""]'),
	isRaster = (img || {src: null}).src == win.location.href,
	isSVG = !isRaster && (doc instanceof win['SVGDocument'] || (root && root.nodeName == 'svg') || /svgz?$/i.test(win.location.pathname));

if (isSVG && win.location.hash.indexOf('#IMAGUS_SVG') > -1) {
	if (win.location.hash.indexOf('#IMAGUS_SVG_GET') > -1) {
		var i = 10, wh, isSVG,
		sendDimensions = function () {
			if (!doc.documentElement) { return; }
			doc.documentElement.suspendRedraw && doc.documentElement.suspendRedraw(10000);
			if (isSVG = doc.documentElement.nodeName == 'svg') {
				wh = {'w': parseInt(doc.documentElement.getAttribute('width'), 10), 'h': parseInt(doc.documentElement.getAttribute('height'), 10)};

				if (!wh['w'] || !wh['h']) {
					wh = doc.documentElement['getBBox']();
					if (!(!isNaN(parseFloat(wh.width)) && isFinite(wh.width))) { return; }
					wh = {'w': wh.width, 'h': wh.height};
				}
			}

			clearInterval(interv);
			oex.postMessage({'cmd': 'svg_info', 'svg': isSVG, 'url': win.location.href, 'wh': wh});
		},
		interv = setTimeout(function () { sendDimensions(); if (--i) { clearInterval(interv); return; } }, 500);

		doc.documentElement && sendDimensions();
	}
/*	else {
		root && root.suspendRedraw && doc.documentElement.suspendRedraw(5000);
		document.addEventListener('DOMContentLoaded', function () { root.unsuspendRedrawAll(); }, false);
	}*/

	return;
}

if (isRaster/* || (doc instanceof win['SVGDocument'] && doc.URL == win.top.location.href)*/) {
	// Y U SO SLOW localStorage???
	var prefs = {dam: cfg['dam']};
	if (prefs.dam == '4') { return; }

	img.naturalWidth = 0;
	img.error = true;

	if (prefs.dam == '5') {
		doc.body.style.padding = '0';
		img.onclick = win.onkeypress = win.onmousedown = win.onmouseup = win.onmousemove = null;
		return;
	}

	//if (isRaster) {
		img = new Image();

		img.onerror = function() {
			img = {error: true};
			doc.body.innerHTML = '<h2 style="padding-top:100px;text-align:center;text-shadow:1px 1px 10px #000;color:#fff">' + LNG['IMG_FAILED'] + '</h2>';
		};
		// clone to skip incompatibilities
		img.src = doc.images[0].src;

		if (img.src.indexOf('data:') === 0) {
			img.alt = 'Image (inline)';
			doc.title = 'Image';
		}
		else {
			img.alt = (win.location.pathname.match(/([^\/]+)?$/)[0] + win.location.search) || 'Image';
		}

		document['head'].innerHTML = '';

		if (img.naturalWidth === 0) {
			doc.body.innerHTML = '<h2 style="padding-top:100px;text-align:center;text-shadow:1px 1px 10px #000;color:#fff">' + img.alt + '</h2>';
			doc.body.firstElementChild.onclick = function () {this.parentNode.appendChild(img); this.parentNode.removeChild(this);};
		}
	/*}
	else {
		return;
		var img = '';
	}*/

	oex.onmessage = function () {
		if (img.error) { return; }

		// preferences
		var prefs = {
			imgInfo: cfg['imginfo'],
			dam: ~~cfg['dam'],
			pos: cfg['pos'],
			backg: cfg['backg'] || '',
			imgBg: cfg['imgbg'] || '',
			imgBorder: cfg['imgborder'] || '',
			hideSB: ~~cfg['hidesb'],
			mDownDelay: ~~cfg['mdowndelay'],
			pixelmove: ~~cfg['pixelmove'],
			hlonger: ~~cfg['hlonger'],
			dragScroll: 1.15 //~~cfg['dragscroll'] ? Math.max(Math.min(cfg['dragscroll'], 2), 1.05) : 0,
			//transDur: ~~cfg['transdur']
		},
		keys = JSON.parse(cfg['keys'] || '{}'),

		sX, sY,
		noFit = {cur: false, real: false},
		progress = null,
		cancelAction = false,
		fZoom = null,
		pixelThresHold = prefs.pixelmove,
		dragScroll = [],
		borderSize = 0,
		init = {loop: 0, wait: 300, maxLoop: 1000},
		MAXSIZE = 0x7fff;

		root || (root = doc.documentElement);

		if (!/^[ts]:/.test(prefs.imgInfo) || prefs.imgInfo == '%url') {
			prefs.imgInfo = false;
		}
/*		else if (prefs.imgInfo[0] == 's') {
			doc.addEventListener('mouseover', img.imgInfo, false);
			doc.addEventListener('mouseup', img.imgInfo, false);
		}*/

		//setTimeout(function () {document['head'].innerHTML += '<link rel="shortcut icon" href="http://www.google.com/s2/favicons?domain=' +  win.location.host + '">';}, 0);

		var nodeStyle = '', docStyle = 'body{width:100%;height:100%;margin:0;font:12px Verdana,"DejaVu Sans"}.m_1{max-width:100%;max-height:100%;width:auto;height:auto}.m_2{width:100%;height:auto}.m_3{height:100%;width:auto}';

		// scrollbars
		if (prefs.hideSB) {
			nodeStyle += 'overflow:hidden;';
		}

		docStyle += 'html{height:100%;' + nodeStyle + '}';
		nodeStyle = '';

		// background
		if (!!prefs.backg) {
			if (prefs.backg == 'cb') {
				nodeStyle += 'background-image:url(data:image/gif;base64,R0lGODlhFAAUAPABAOjo6P///yH5BAAKAAAALAAAAAAUABQAAAIohI+hy+jAYnhJLnrsxVBP7n1YyHVaSYKhh7Lq+VotPLo1TaW3HEtlAQA7);';
			}
			else if (/^(?:http|-o-skin)/i.test(prefs.backg)) { nodeStyle += 'background-image:' + prefs.backg + ';'; }
			else { nodeStyle += 'background-color:' + prefs.backg + ';'; }
		}

		if (nodeStyle !== '') {
			root.style.cssText = nodeStyle;
		}

		nodeStyle = '';

		// image background
		if (!!prefs.imgBg) {
			if (prefs.imgBg == 'cb') {
				nodeStyle += 'background-image:url(data:image/gif;base64,R0lGODlhFAAUAPABAOjo6P///yH5BAAKAAAALAAAAAAUABQAAAIohI+hy+jAYnhJLnrsxVBP7n1YyHVaSYKhh7Lq+VotPLo1TaW3HEtlAQA7);';
			}
			else if (/^(?:http|-o-skin)/i.test(prefs.imgBg)) { nodeStyle += 'background-image:' + prefs.imgBg + ';'; }
			else { nodeStyle += 'background-color:' + prefs.imgBg + ';'; }
		}

		if (!!prefs.imgBorder) {
			nodeStyle += 'border:' + (img.style.border = prefs.imgBorder) + ';';
			borderSize = parseInt(prefs.imgBorder, 10);

			if (!prefs.imgBorder.match(/!\s*important\s*$/) && borderSize > 100) {
				borderSize = 100;
				nodeStyle += 'border-width:' + borderSize + 'px;';
			}

			nodeStyle += 'background-clip:padding-box;box-sizing:border-box;';
		}

		docStyle += 'img{position:absolute;' + nodeStyle + '}';

		var load = function(noneedinterval) {
			if (img.error) {
				if (progress) { clearInterval(progress); }
				return;
			}

			if (img.width > 0 || noneedinterval) {
				clearInterval(progress);
				progress = null;

				document['head'].innerHTML = '<style>' + docStyle + 'body>img{max-width:' + Math.min(MAXSIZE, Math.floor(img.naturalWidth * MAXSIZE / img.naturalHeight)) + 'px;max-height:' + Math.min(MAXSIZE, Math.floor(img.naturalHeight * MAXSIZE / img.naturalWidth)) + 'px}' + '</style>';

				doc.body.innerHTML = '';
				doc.body.appendChild(img);

				// Opera does not support images larger than ??MP
				/*if (img.naturalWidth * img.naturalHeight > 100 * 10E6) {
					doc.body.innerHTML = '<h2>' + LNG['IMG_TOO_LARGE'] + '</h2>';
					return;
				}*/

				// Opera bug? - Clicking on image after 2^14 - 2 pixels in width, won't handle as image
				//if (img.naturalWidth > 16382) {
					//
				//}

				// image resizer
				img.resize = function(m, w, h) {
					if (m === 4) {
						prefs.dam = 4;
						this.style.display = 'none';
						this.parentNode.style.backgroundImage = 'url("'+this.src+'")';
						this.setPos();
						return;
					}
					else if (prefs.dam === 4) {
						this.style.display = 'run-in';
						this.parentNode.style.backgroundImage = '';
					}
					else if (m === -1 || (m === -1 && fZoom)) {
						this.style.width = w;
						h && (this.style.height = h);

						if ((w == '' || w === this.naturalWidth) && (h == '' || h === this.naturalHeight)) {
							m = 0;
						}
					}

					if (m !== -1 && prefs.dam === -1) {
						this.style.width = this.style.height = '';
					}

					this.className !== 'm_' + m && (this.className = 'm_' + m);

					prefs.dam = m;

					if (this.naturalWidth && this.naturalHeight && this.calcFit) {
						this.setPos();
						this.calcFit();
						this.hScroll();
						this.setCur();
						this.setInfo();
					}
				};

				img.setInfo = function() {
					if (!prefs.imgInfo || !(img.naturalWidth && img.naturalHeight)) { return; }

					var info = prefs.imgInfo.replace('%w', img.width).replace('%h', img.height).replace('%ow', img.naturalWidth).replace('%oh', img.naturalHeight).replace('%url', win.location).replace('%name', img.alt);

					if (prefs.imgInfo.indexOf('%perc') > 0) {
						info = info.replace('%perc', (~~(0.5 + 1E4 * (img.width / img.naturalWidth)) / 100));
					}

					if (prefs.imgInfo.indexOf('t:') === 0) {
						doc.title = info.substr(2);
					}
					else {
						win.status = info.substr(2);
					}
				}

				var hLayer, createHelper = function () {
					if (hLayer) { return; }
					hLayer = doc.createElement('DIV');
					hLayer.style.cssText = 'position:fixed;display:none;z-index:665;left:0px;top:0px;width:100%;height:100%;box-sizing:border-box;background-clip:padding-box;white-space:nowrap;color:#fff;text-shadow:1px 1px 1px #000;overflow:hidden';

					hLayer.hide = function(e) {
						if (cancelAction || (e && e.shiftKey)) { return; }

						hLayer.style.display = 'none';
					};

					doc.body.appendChild(hLayer);
				};

				img.setPos = function() {
					if (prefs.pos.length === 2) {
						var bgM = (prefs.dam === 4), bgPos = '';

						var r = this.currentdeg && Math.sin(this.currentdeg) ? true : false;

						switch (prefs.pos.charAt(1)) {
							case '0' : if (bgM) { bgPos = 'top '; } else { this.style.top = '0px'; } break;
							case '2' : if (bgM) { bgPos = 'bottom '; } else { this.style.top = Math.max(0, doc.body.clientHeight - (r ? this.width : this.height) - borderSize * 2) + 'px'; } break;
							default: if (bgM) { bgPos = 'center '; } else { this.style.top = Math.max(0, (doc.body.clientHeight - (r ? this.width : this.height)) / 2 - borderSize) + 'px'; }
						}

						switch (prefs.pos.charAt(0)) {
							case '0' : if (bgM) { bgPos += 'left'; } else { this.style.left = '0px'; } break;
							case '2' : if (bgM) { bgPos += 'right'; } else { this.style.left = Math.max(0, doc.body.clientWidth - (r ? this.height : this.width) - borderSize * 2) + 'px'; } break;
							default : if (bgM) { bgPos += 'center'; } else { this.style.left = Math.max(0, (doc.body.clientWidth - (r ? this.height : this.width)) / 2 - borderSize) + 'px'; }
						}

						if (bgM) { this.parentNode.style.backgroundPosition = bgPos; }
					}
				};

				img.calcFit = function () {
					noFit = {
						cur: (this.width <= win.innerWidth && this.height <= win.innerHeight),
						real: (this.naturalWidth <= win.innerWidth && this.naturalHeight <= win.innerHeight)
					};
				};

				img.wheelZoom = function (e) {
					e.preventDefault();

					var point = e.target.nodeName == 'IMG';

					if (point || e.keypress) {
						var w = img.width, h = img.height;
					}

					if (e.wheelDelta > 0) {
						var width = img.width * (e.altKey || e.accelerate ? 1.4 : 1.2), height = img.height * (e.altKey || e.accelerate ? 1.4 : 1.2);
						img.resize(-1, (width > 10 ? width : width + 2) + 'px', height + 'px');
					}
					else {
						img.resize(-1, Math.max(1, img.width * (e.altKey || e.accelerate ? 0.6 : 0.8)) + 'px', img.height * (e.altKey || e.accelerate ? 0.6 : 0.8)  + 'px');
					}

					if ((point || e.keypress) && w !== img.width) {
						win.scrollTo(e.offsetX * img.width / w - e.clientX, e.offsetY * img.height / h - e.clientY);
					}
				};

				if (cfg['scrollzoom'] == '0') {
					if (prefs.hideSB) {
						var onWheelVertical = function (e) {
							win.scrollBy(0, -e.wheelDelta);
							e.preventDefault();
						};

						doc.addEventListener('mousewheel', onWheelVertical, false);
					}

					var onWheelHorizontal = function (e) {
						win.scrollBy(-e.wheelDelta, 0);
						e.preventDefault();
					};

					img.hScroll = function (force) {
						var hS;

						switch (prefs.dam) {
							case -1:
							case 0: hS = (win.innerWidth < this.width && prefs.hlonger && this.height <= (this.width / prefs.hlonger) ? true : false); break;
							case 3: hS = (win.innerWidth < this.width ? true : false); break;
							default: hS = false;
						}

						if (force) {
							hS = !hS;

							win.onkeyup = function(e) {
								if (e.keyCode === 88) {
									img.hScroll();
									win.onkeyup = null;
								}
							};
						}
						if (hS) { doc.addEventListener('mousewheel', onWheelHorizontal, false); if (prefs.hideSB) { doc.removeEventListener('mousewheel', onWheelVertical, false); }}
						else { doc.removeEventListener('mousewheel', onWheelHorizontal, false); if (prefs.hideSB) { doc.addEventListener('mousewheel', onWheelVertical, false); }}
					};
				}
				else {
					img.hScroll = function () {};

					doc.addEventListener('mousewheel', img.wheelZoom, false);
				}

				if (cfg['cursor'] == '1') {
					img.setCur = function () {
						if (this.width > win.innerWidth || this.height > win.innerHeight) {
							this.style.cursor = 'move';
						}
						else if (((win.innerHeight >= this.height && win.innerWidth >= this.width) && (win.innerHeight < this.naturalHeight || win.innerWidth < this.naturalWidth)) ||
						(noFit.cur && noFit.real && (this.height < this.naturalHeight || this.width < this.naturalWidth))) {
							this.style.cursor = 'zoom-in';
						}
						else { this.style.cursor = 'default'; }
					};
				}
				else {
					img.setCur = function () {};
				}

				// don't upscale large images
				if ((prefs.dam === 2 && img.naturalWidth < win.innerWidth) || (prefs.dam === 3 && img.naturalHeight < win.innerHeight)) {
					prefs.dam = 0;
				}

				img.resize(prefs.dam);
				img.setPos();
				setTimeout(img.setInfo, 1500);

				win.addEventListener('resize', function () {
					img.setPos();
					img.calcFit();
					img.hScroll();
					img.setCur();
					img.setInfo();
				}, false);

				var cxmenu, contextmenu = function (mx, my) {
					createHelper();

					if (cxmenu) {
						cxmenu.style.left = mx + 'px';
						cxmenu.style.top = my + 'px';
						hLayer.style.border = 0;
						hLayer.style.left = 0;
						hLayer.style.top = 0;
						hLayer.style.width = '100%';
						hLayer.style.height = '100%';
						hLayer.style.display = 'block';
						return;
					}

					/*-o-transition:opacity 300ms;opacity:0;*/
					document['head'].firstChild.innerText += '#O_EX_CM{display:none;position:fixed;text-shadow:none;z-index:666}#O_EX_CM,#O_EX_CM ul{background-color:#f0f0f0;border:1px solid #a0a0a0;box-shadow:2px 2px 2px #8e8e8e;display:inline-block;list-style:none;margin:0;padding:2px}#O_EX_CM li{position:relative}#O_EX_CM li ul{display:none;left:100%;position:absolute;top:-5px}#O_EX_CM li:hover ul{display:block}#O_EX_CM li a+i{color:grey;font-style:normal;position:absolute;right:5px;text-shadow:0 0 1px #fff;top:2px}#O_EX_CM .title{color:silver;letter-spacing:1px;padding:10px 5px 6px;text-shadow:0 0 0 #000}#O_EX_CM li:empty{border-bottom:1px solid #fff;border-top:1px solid #a0a0a0;margin:5px 7px 4px}#O_EX_CM .title:first-child{padding-top:0}#O_EX_CM a{border:1px solid transparent;color:#000;cursor:default;display:block;padding:2px 40px 2px 10px;text-decoration:none;white-space:nowrap}#O_EX_CM a:hover{background-color:#46a9ff;border:1px solid #1676ff;color:#fff}';
					cxmenu = doc.createElement('UL');
					cxmenu.id = 'O_EX_CM';

					hLayer.appendChild(cxmenu);
					hLayer.addEventListener('mouseup', hLayer.hide, false);

					var generateMenu = function (ext_menu_data) {
						var tmpel, mfragment = doc.createDocumentFragment(), a, key, i, l;

						for (i = 0, l = ext_menu_data.length; i < l; ++i) {
							if (!ext_menu_data[i].length) {
								mfragment.appendChild(doc.createElement('LI'));
							}
							else if (ext_menu_data[i][1] instanceof Array) {
								tmpel = doc.createElement('LI');
								a = doc.createElement('A'); ul = doc.createElement('UL');
								a.innerText = ext_menu_data[i][0];
								tmpel.appendChild(a);

								if (ext_menu_data[i][2]) {
									key = doc.createElement('I');
									key.innerHTML = ext_menu_data[i][2];
									tmpel.appendChild(key);
								}

								ul.appendChild(generateMenu(ext_menu_data[i][1]));
								tmpel.appendChild(ul);
								mfragment.appendChild(tmpel);
							}
							else {
								tmpel = doc.createElement('LI');
								a = doc.createElement('A');
								a.innerText = ext_menu_data[i][0];

								if (ext_menu_data[i][1]) { a.onclick = ext_menu_data[i][1]; }
								tmpel.appendChild(a);

								if (ext_menu_data[i][2]) {
									key = doc.createElement('I');
									key.innerText = ext_menu_data[i][2];
									tmpel.appendChild(key);
								}

								mfragment.appendChild(tmpel);
							}
						}

						return mfragment;
					};

					var tmpel, mfragment = doc.createDocumentFragment();

					tmpel = doc.createElement('LI');
					tmpel.className = 'title';
					tmpel.innerText = widget.name;
					mfragment.appendChild(tmpel);
					mfragment.appendChild(generateMenu([
						[LNG['ORIGINAL_SIZE'], function() { img.resize(0); }, String.fromCharCode(keys['modeAuto'])],
						[LNG['BEST_FIT'], function() { img.resize(1); }, String.fromCharCode(keys['modeFit'])],
						[LNG['FIT_TO_WIDTH'], function() { img.resize(2); }, String.fromCharCode(keys['modeFitW'])],
						[LNG['FIT_TO_HEIGHT'], function() { img.resize(3); }, String.fromCharCode(keys['modeFitH'])],
						[LNG['MORE'], [
							[LNG['TO_BACKGROUND'], function() { img.resize(4); }, String.fromCharCode(keys['modeBg'])],
							[LNG['CUSTOM_SIZE'], function() { img.setSize(); }, String.fromCharCode(keys['customSize'])],
							[LNG['RESET_IMAGE'], function() { img.reset(); }, 'Esc']
						], '&#187;'],
						[],
						[LNG['TRANSFORM'], [
							[LNG['FLIP_H'], function() { img.flip(1); }, String.fromCharCode(keys['flipH'])],
							[LNG['FLIP_V'], function() { img.flip(0); }, String.fromCharCode(keys['flipV'])],
							[],
							[LNG['ROT_LEFT'], function() { img.rotate(0); }, String.fromCharCode(keys['rotateLeft'])],
							[LNG['ROT_RIGHT'], function() { img.rotate(1); }, String.fromCharCode(keys['rotateRight'])]
						], '&#187;'],
						[LNG['PREFERENCES'], function() { oex.postMessage({'cmd':'open', 'url':'options.html'}); }, String.fromCharCode(keys['prefs'])]
					]));

					cxmenu.style.cssText = 'left:' + mx + 'px;top:' + my + 'px;display:block';
					cxmenu.appendChild(mfragment);

					hLayer.style.border = 0;
					hLayer.style.left = 0;
					hLayer.style.top = 0;
					hLayer.style.width = '100%';
					hLayer.style.height = '100%';
					hLayer.style.display = 'block';
				};

				doc.addEventListener('contextmenu', function(e) {
					win.onmousemove = null;
					if (progress) { clearTimeout(progress); progress = null; }
					if (cancelAction === 2) { cancelAction = false; e.preventDefault(); }
				}, false);

				var onmove = function (e) {
					if (fZoom) {
						if (fZoom.stage === 0) {
							if (!e.shiftKey) {
								fZoom = null;
								return;
							}

							createHelper();
							hLayer.innerHTML = '';
							cxmenu = null;

							var rot = img.currentdeg && Math.sin(img.currentdeg) ? true : false,
								w = rot ? img.height : img.width,
								h = rot ? img.width : img.height;
							if (w > win.innerWidth) {
								hLayer.style.left = parseInt(borderSize, 10);
								hLayer.style.width = win.innerWidth + 'px';
							}
							else {
								hLayer.style.left = (img.offsetLeft + borderSize) + 'px';
								hLayer.style.width = w + 'px';
							}

							if (h > win.innerHeight) {
								hLayer.style.top = parseInt(borderSize, 10);
								hLayer.style.height = win.innerHeight + 'px';
							}
							else {
								hLayer.style.top = (img.offsetTop + borderSize) + 'px';
								hLayer.style.height = h + 'px';
							}

							// helper width, height
							fZoom.hW = parseInt(hLayer.style.width, 10);
							fZoom.hH = parseInt(hLayer.style.height, 10);

							// helper top, left
							fZoom.hT = parseInt(hLayer.style.top, 10);
							fZoom.hL = parseInt(hLayer.style.left, 10);

							// helper right, bottom
							fZoom.hR = fZoom.hL + fZoom.hW;
							fZoom.hB = fZoom.hT + fZoom.hH;

							fZoom.t = Math.max(0, fZoom.cY - fZoom.hT);
							fZoom.b = Math.max(0, fZoom.hB - fZoom.cY);
							fZoom.l = Math.max(0, fZoom.cX - fZoom.hL);
							fZoom.r = Math.max(0, fZoom.hR - fZoom.cX);

							// area width, height
							//fZoom.sW = Math.max(0, fZoom.hW - fZoom.hL - fZoom.hR);
							//fZoom.sH = Math.max(0, fZoom.hH - fZoom.hT - fZoom.hB);

							hLayer.style.borderStyle = 'solid';
							hLayer.style.borderColor = 'rgba(0,0,0,.5)';
							//hLayer.style.backgroundColor = 'rgba(0,255,255,.5)';
							hLayer.style.borderWidth = fZoom.t + 'px ' + fZoom.r + 'px ' + fZoom.b + 'px ' + fZoom.l + 'px';
							hLayer.style.display = 'block';

							++fZoom.stage;
						}
						else {
							if (e.ctrlKey) {
								if (fZoom.sX) {
									var x = fZoom.sX - e.screenX, y = fZoom.sY - e.screenY;

									if (y !== 0) {
										hLayer.style.borderBottomWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderBottomWidth, 10) + y), fZoom.hH) + 'px';
										hLayer.style.borderTopWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderTopWidth, 10) - y), fZoom.hH) + 'px';
									}

									if (x !== 0) {
										hLayer.style.borderRightWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderRightWidth, 10) + x), fZoom.hW) + 'px';
										hLayer.style.borderLeftWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderLeftWidth, 10) - x), fZoom.hW) + 'px';
									}
								}

								fZoom.sX = e.screenX;
								fZoom.sY = e.screenY;

								return;
							}

							if (fZoom.sX) {
								fZoom.sX = null;
								fZoom.sY = null;
								/*fZoom.cX = fZoom.hL + (fZoom.cX < e.clientX ? parseInt(hLayer.style.borderLeftWidth, 10) : fZoom.hW - parseInt(hLayer.style.borderRightWidth, 10));
								fZoom.cY = fZoom.hT + (fZoom.cY < e.clientY ? parseInt(hLayer.style.borderTopWidth, 10) : fZoom.hH - parseInt(hLayer.style.borderBottomWidth, 10));*/
								if (fZoom.hL + parseInt(hLayer.style.borderLeftWidth, 10) < e.clientX) { fZoom.cX = fZoom.hL + parseInt(hLayer.style.borderLeftWidth, 10); }
								else { fZoom.cX = fZoom.hL + fZoom.hW - parseInt(hLayer.style.borderRightWidth, 10); }

								if (fZoom.hT + parseInt(hLayer.style.borderTopWidth, 10) < e.clientY) { fZoom.cY = fZoom.hT + parseInt(hLayer.style.borderTopWidth, 10); }
								else { fZoom.cY = fZoom.hT + fZoom.hH - parseInt(hLayer.style.borderBottomWidth, 10); }

								//borders
								fZoom.t = Math.max(0, fZoom.cY - fZoom.hT);
								fZoom.b = Math.max(0, fZoom.hB - fZoom.cY);
								fZoom.l = Math.max(0, fZoom.cX - fZoom.hL);
								fZoom.r = Math.max(0, fZoom.hR - fZoom.cX);
							}

							var t, r, b, l;

							if (fZoom.cY < e.clientY) {
								b = Math.max(0, fZoom.hB - e.clientY);
								t = fZoom.t;
							}
							else {
								b = fZoom.b;
								t = Math.max(0, e.clientY - fZoom.hT);
							}

							if (fZoom.cX < e.clientX) {
								r = Math.max(0, fZoom.hR - e.clientX);
								l = fZoom.l;
							}
							else {
								r = fZoom.r;
								l = Math.max(0, e.clientX - fZoom.hL);
							}

							//hLayer.innerText = (fZoom.hW - parseInt(hLayer.style.borderRightWidth, 10) - parseInt(hLayer.style.borderLeftWidth, 10)) + 'x' + (fZoom.hH - parseInt(hLayer.style.borderTopWidth, 10) - parseInt(hLayer.style.borderBottomWidth, 10));
							hLayer.style.borderWidth = t + 'px ' + r + 'px ' + b + 'px ' + l + 'px';
						}

						return;
					}

					if (progress) { clearTimeout(progress); progress = null;}

					if (sX === true || prefs.pixelmove < 1 || noFit.cur || !parseInt(prefs.pixelmove, 10)) { win.onmousemove = null; return;}

					if (!--pixelThresHold) {
						win.scrollBy(sX - e.screenX, sY - e.screenY);

						sX = e.screenX;
						sY = e.screenY;
						pixelThresHold = prefs.pixelmove;
					}

					if (dragScroll.length !== 3) {
						dragScroll = [ [e.screenX, e.screenY], [e.screenX, e.screenY], [e.screenX, e.screenY] ];
						return;
					}

					//dragScroll = [[dragScroll[1][0], dragScroll[1][1]], [dragScroll[2][0], dragScroll[2][1]], [e.screenX, e.screenY]];

					dragScroll[0] = [dragScroll[1][0], dragScroll[1][1]];
					dragScroll[1] = [dragScroll[2][0], dragScroll[2][1]];
					dragScroll[2] = [e.screenX, e.screenY];

					img.dragScrollTime = Date.now();
				};

				if (prefs.dragScroll !== 0) {
					var stopScroll = function (e, c_action) {
						if (dragScroll.length) {
							clearInterval(progress);
							progress = null;
							cancelAction = c_action ? true : false;
							dragScroll = [];
							img.dragScrollTime = false;
						}

						if (e) {
							doc.removeEventListener('mousewheel', stopScroll, false);
						}
					};

					var scroll = function () {
						win.scrollBy(dragScroll[0], dragScroll[1]);

						if (dragScroll[0]) {
							if (Math.abs(dragScroll[0]) < 1) {
								dragScroll[0] = 0;
							}

							dragScroll[0] /= prefs.dragScroll;
						}

						if (dragScroll[1]) {
							if (Math.abs(dragScroll[1]) < 1) {
								dragScroll[1] = 0;
							}

							dragScroll[1] /= prefs.dragScroll;
						}

						var atRight = root.scrollWidth - win.scrollX === root.clientWidth,
							atBottom = root.scrollHeight - win.scrollY === root.clientHeight;

						if (!(dragScroll[0] && dragScroll[1]) || (!win.scrollY && !win.scrollX) || (!win.scrollY && atRight) || (atBottom && !win.scrollX) || (atBottom && atRight)) {
							stopScroll();
						}
					};
				}

				img.addEventListener('mousedown', function(e) {
					if (e.button === 1 || e.ctrlKey || e.altKey) { return; }

					/*var o = ['clientX', 'clientY', 'offsetX', 'offsetY', 'pageX', 'pageY', 'screenX', 'screenY'];
					var a = ''; for (var i in o) a += o[i] + ' - ' + e[o[i]] + '\n'; d(a); cancelAction = true; return;*/

					if ((e.button === 0 && prefs.dam < 4) || e.button === 2) {
						if (prefs.pixelmove === 0) {
							win.onmousemove = function () {if (progress) { clearTimeout(progress); progress = null; } win.onmousemove = null; };
						}
						else {
							win.onmousemove = onmove;
						}

						if (e.button === 2) {
							sX = true;
						}
						else {
							e.preventDefault();
							sX = e.screenX;
							sY = e.screenY;
						}
					}

					if (!prefs.mDownDelay) {
						return;
					}

					// for fine move
					if (e.shiftKey || fZoom === 0) {
						cancelAction = true;

						// contextmenu
						if (e.button === 2) {
							cancelAction = 2;
							contextmenu(e.clientX, e.clientY);
						}
						else {
							fZoom = {stage:0, cX: e.clientX, cY: e.clientY};

							if (win.onmousemove === null) {
								win.onmousemove = onmove;
							}
						}
					}

					// is dragScrolling
					if (progress) {
						stopScroll && stopScroll(false, true);

						if (e.button === 0) {
							return;
						}
					}

					if (e.shiftKey) { return; }

					progress = setTimeout(function () {
						cancelAction = true;
						progress = null;

						// contextmenu
						if (e.button === 2) {
							cancelAction = 2;

							try { if (img.src !== win.top.location.href) { oex.postMessage({'cmd':'open', 'url': img.src, nf: false}); return; } } catch (ex) {}

							contextmenu(e.clientX, e.clientY);
							return;
						}

						var x, y, tmpsize;

						if (prefs.dam === 2 || img.width === win.innerWidth) {
							tmpsize = img.width;

							img.resize(3);

							x = e.offsetX * img.width / tmpsize - win.innerWidth / 2;
							y = 0;
						}
						else {
							tmpsize = img.height;

							img.resize(2);

							x = 0;
							y = e.offsetY * img.height / tmpsize - win.innerHeight / 2;
						}

						win.scrollTo(x, y);
					}, prefs.mDownDelay);
				}, false);

				doc.addEventListener('mouseup', function(e) {
					if (e.button !== 0) { return; }

					if (prefs.dam < 4) {
						win.onmousemove = null;

						if (fZoom) {
							hLayer.style.display = 'none';
							var nimgw, nimgh,
							w = fZoom.hW - parseInt(hLayer.style.borderRightWidth, 10) - parseInt(hLayer.style.borderLeftWidth, 10),
							h = fZoom.hH - parseInt(hLayer.style.borderTopWidth, 10) - parseInt(hLayer.style.borderBottomWidth, 10),
							scrollbars = prefs.hideSB ? 0 : 17, // not always 17
							winW = win.innerWidth - scrollbars,
							winH = win.innerHeight - scrollbars;

							var fitW = winW < w * winH / h;

							fitW = e.ctrlKey ? !fitW : fitW;

							if (fitW) {
								nimgw = img.width * winW / w;
								nimgh = nimgw * img.height / img.width;
							}
							else {
								nimgh = img.height * winH / h;
								nimgw = nimgh * img.width / img.height;
							}

							if (nimgw > MAXSIZE) {
								nimgw = MAXSIZE;
								nimgh = img.height * MAXSIZE / img.width;
							}

							if (nimgh > MAXSIZE) {
								nimgw = img.width * MAXSIZE / img.height;
								nimgh = MAXSIZE;
							}

							var cx = (win.scrollX + parseInt(hLayer.style.borderLeftWidth, 10) + w / 2) * nimgw / img.width - win.innerWidth / 2 - scrollbars;
							var cy = (win.scrollY + parseInt(hLayer.style.borderTopWidth, 10) + h / 2) * nimgh / img.height - win.innerHeight / 2 - scrollbars;

							img.resize(-1, nimgw + 'px', nimgh + 'px');

							win.scrollTo(cx, cy);

							fZoom = null;
							cancelAction = false;
							hLayer.innerText = '';
						}
						else if (dragScroll.length === 3) {
							var x = dragScroll[0][0] - dragScroll[2][0], y = dragScroll[0][1] - dragScroll[2][1];

							if ((Date.now() - img.dragScrollTime) > 100) { return; }

							//x = x < 0 ? Math.max(-1e3, x) : Math.min(1e3, x);
							//y = y < 0 ? Math.max(-1e3, y) : Math.min(1e3, y);

							if (x || y) {
								dragScroll = [x, y];
								progress = setInterval(scroll, 0xF);
								doc.addEventListener('mousewheel', stopScroll, false);
							}
						}
					}
				}, false);

				img.addEventListener('click', function(e) {
					if (progress) { clearTimeout(progress); progress = null; }
					if (cancelAction) { cancelAction = false; return; }

					if (e.button !== 0) { return; }

					if (prefs.dam < 2 && noFit.real) {
						if (prefs.dam === -1) { this.resize(0); }
						else if (win.innerWidth < this.naturalWidth * win.innerHeight / this.naturalHeight) { this.resize(2); }
						else { this.resize(3); }
					}
					else if (prefs.dam === 1 || noFit.cur) {
						if (this.naturalWidth === this.width && this.naturalHeight === this.height) { return; }

						var x, y;

						x = e.offsetX;
						y = e.offsetY;

						if (this.scale) {
							if (this.scale.h === -1) {
								x = this.width - e.offsetX;
							}

							if (this.scale.v === -1) {
								y = this.height - e.offsetY;
							}
						}

						x = x * this.naturalWidth / this.width - win.innerWidth / 2;
						y = y * this.naturalHeight / this.height - win.innerHeight / 2;

						this.resize(0);

						win.scrollTo(x, y);
					}
					else { this.resize(1); }
				}, false);

				doc.addEventListener('keypress', function(e) {
					if (e.keyCode === 43 || e.keyCode === 45) {
						e.accelerate = e.ctrlKey;
						e.keypress = true;

						if (e.keyCode === 43) {
							e.wheelDelta = 1;
						}
						else {
							e.wheelDelta = -1;
						}

						e.offsetX = root.scrollLeft + img.offsetLeft + doc.body.clientWidth / 2;
						e.offsetY = root.scrollTop + img.offsetTop + doc.body.clientHeight / 2;
						e.clientX = doc.body.clientWidth / 2;
						e.clientY = doc.body.clientHeight / 2;

						img.wheelZoom(e);
					}
				}, false);

				doc.addEventListener('keydown', function(e) {
					stopScroll();

					if ((fZoom && e.keyCode !== keys['reset']) || /(?:TEXTAREA|INPUT|SELECT)/.test(e.target.nodeName)) { return; }

					if (e.ctrlKey) {
						if (e.shiftKey && ' 37 38 39 40 '.indexOf(' ' + e.keyCode + ' ') != -1) {
							var newpos,
							x = prefs.pos.charAt(0),
							y = prefs.pos.charAt(1);

							switch (e.keyCode) {
								case 37: --x; break;
								case 39: ++x; break;
								case 38: --y; break;
								case 40: ++y;
							}

							x < 0 ? x = '0' : x > 2 && (x = '2');
							y < 0 ? y = '0' : y > 2 && (y = '2');

							newpos = x + y;

							if (newpos !== prefs.pos) {
								prefs.pos = newpos;
								img.setPos();
							}
						}

						return;
					}

					switch (e.keyCode) {
						case keys['modeAuto']: case keys['modeFit']: case keys['modeFitW']: case keys['modeFitH']: case keys['modeBg']: img.resize(e.keyCode - 49); break;

						case keys['customSize']: img.setSize(); break;

						case keys['reset'] : img.reset(); break;

						case keys['prefs'] : oex.postMessage({'cmd':'open', 'url':'options.html'}); break;

						case keys['rotateLeft'] : img.rotate(0); break;
						case keys['rotateRight'] : img.rotate(1); break;

						case keys['flipH'] : img.flip(0); break;
						case keys['flipV'] : img.flip(1); break;

						case keys['cycle'] : img.cycle(); break;

						case keys['contextMenu'] : hLayer && hLayer.style.display == 'block' ? hLayer.hide() : contextmenu(win.innerWidth / 2 - 100, win.innerHeight / 2 - 100); break;

						case 88 : img.hScroll(true); break;
					}
				}, false);

				img.cycle = function () {
					var n_s = prefs.dam + 1;

					if (n_s === 1) { ++n_s; }
					else if (n_s > 3) { n_s = 0; }

					this.resize(n_s);
				};

				img.reset = function () {
					if (doc.readyState !== 'complete') { return; }

					if (hLayer) {
						fZoom = null;
						cancelAction = false;

						if (hLayer.style.display == 'block') {
							hLayer.innerHTML = '';
							hLayer.style.display = 'none';
							return;
						}

						doc.body.removeChild(hLayer);
						hLayer = null;
					}

					delete this.currentdeg;
					delete this.scale;
					this.style['OTransform'] = this.style.width = this.style.height = this.parentNode.style['backgroundSize'] = '';
					this.resize(0);
				};

				img.setSize = function () {
					setTimeout(function() {
						var size = prompt('(0 < x,y <= ' + MAXSIZE + ')\n' + LNG['ORIG_DIMENS'] + ': ' + img.naturalWidth + ' x ' + img.naturalHeight, '0');

						if (!size) { return; }

						size = size.replace(/(^\s*|\s*$)/g, '');

						if (/^(\d{1,5}%?)(\s+\d{1,5}%?)?$/i.test(size)) {
							size = size.split(/\s+/);

							if (prefs.dam === 4) {
								if (size[0] == 0) { size[0] = 'auto'; }
								if (size[1] && size[1] == 0) { size[1] = 'auto'; }
								doc.body.style.backgroundSize = size.join(' ');
							}
							else {
								var w = '', h = '';

								if (parseInt(size[0], 10) > 0) {
									w = size[0].indexOf('%') > 0 ? size[0] : Math.min(Math.max(0, size[0]), MAXSIZE) + 'px';
								}

								if (size[1] && parseInt(size[1], 10) > 0) {
									h = size[1].indexOf('%') > 0 ? size[1] : Math.min(Math.max(0, size[1]), MAXSIZE) + 'px';
								}

								img.resize(-1, w, h);
							}
						}
						else { alert(LNG['INCORRECT_VALUE'] + '!'); }
					}, 1);
				};

				img.rotate = function (lr) {
					var rot = this.style['OTransform'].match(/rotate\((\-?\d+(?:\.\d+)?)deg\)/i);

					if (!rot) { this.currentdeg = 0; }

					if (lr) { this.currentdeg += 90; }
					else { this.currentdeg -= 90; }

					if (this.currentdeg !== 0 && Math.cos(this.currentdeg * 0.017453292519943295) === 1) { this.currentdeg = 0; }

					win.status = this.currentdeg;

					if (typeof this.currentdeg !== 'undefined') { rot = 'rotate('+ this.currentdeg +'deg)'; }
					if (this.scale) { rot+=' scale('+this.scale.h+','+this.scale.v+')'; }
					this.style['OTransform'] = rot;
				};

				img.flip = function (ori) {
					if (!this.scale) { this.scale= {h: 1, v: 1 }; }

					if (ori) { this.scale.h = -this.scale.h; }
					else { this.scale.v = -this.scale.v; }

					var flip = (!this.scale.h && !this.scale.v) ? '' : 'scale('+this.scale.h+','+this.scale.v+')';
					if (this.currentdeg) { flip='rotate('+this.currentdeg+'deg) ' + flip; }
					this.style['OTransform'] = flip;
				};
			}
			else if (++init.loop >= init.maxloop) {
				clearInterval(progress);
			}
		};

		if (img.naturalWidth && img.naturalHeight) { load(true); }
		else { progress = setInterval(load, init.wait); }

		oex.onmessage = null;
	};

	win.onkeypress = win.onmousedown = win.onmouseup = null;
}
else {
	var isHTML = document instanceof win['HTMLDocument'] || (doc.documentElement && root.nodeName == 'HTML');

	if (isHTML) {
		var mdownstart,
				rgxBgURL = /"[^"]+"/g, //g for mutlitple backgrounds
				rgxProtCheck = /^\w+:/i,
				rgxRemQueryHash = /[\?#].*$/,
				rgxRemHash = /#.*$/,
				rgxIsSVG = /svgz?$/i,
				rgxDomain = /^(\w+:\/\/[^\/]+)\/.*$/,
				rgxPath = /(\/)[^\/]*$/,
				// http://www.opera.com/docs/specs/presto211/#graphics
				rgxObjImg = /\.(?:jp(?:e|e?g)|a?png|gif|svgz?|webp|w?bmp|cur|ico|xbm|pict|j(?:if|fif?))$/i,

		checkBG = function (match/*, p*/) {
			if (match) {
				var el_images = [], imaddr, i;

				for (i in match) {
					imaddr = match[i].slice(1, -1);

					// need this check, because Opera won't prepend the baseURI to background attribute
					if (!rgxProtCheck.test(imaddr)) {
						imaddr = doc.baseURI.replace(rgxRemQueryHash, '').replace((imaddr.charAt(0) == '/' ? rgxDomain : rgxPath), '$1') + imaddr;
					}

					el_images.push(imaddr);
				}

				//return p && el_images.length > 0 ? {path: p, imgs: el_images} : el_images;
				return el_images.length > 0 ? el_images : null;
			}

			return null;
		},

		checkIMG = function (node) {
			if (node.nodeName == 'IMG' || (node.type == 'image' && /^(?:BUTTON|INPUT)/.test(node.nodeName))) {
				return node.src;
			}
			else if (node.nodeName == 'EMBED') {
				return node.baseURI.replace(rgxRemQueryHash, '').replace((node.src.charAt(0) == '/' ? rgxDomain : rgxPath), '$1') + node.src;
			}
			else if (node.nodeName == 'OBJECT' && node.data !== ''/* && (/^image/i.test(node.type) || rgxObjImg.test(node.data))*/) {
				return node.data;
			}
			else if (node.nodeName == 'AREA') {
				var img = doc.querySelector('img[usemap="#' + node.parentNode.name + '"]');
				return img.src;
			}
			else if (node.nodeName == 'VIDEO' && node.poster !== '') {
				return node.poster;
			}

			return false;
		};
	}

	win.opera.addEventListener('BeforeEvent.mousedown', function (e) {
		if (e.event.button === 2) { mdownstart = Date.now(); }
	}, false);

	win.opera.addEventListener('BeforeEvent.contextmenu', function (ev) {
		var e = ev.event, img, el, i, bgImages = [];

		if (e.button !== 2) { return; }
		var elapsed = (Date.now() - mdownstart) >= 300;
		mdownstart = 0;

		if (e.ctrlKey && e.altKey && elapsed) {
			ev.preventDefault();
			e.preventDefault();
			oex.postMessage({'cmd':'favi', nf: e.shiftKey});
			return;
		}

		if (e.ctrlKey && elapsed) {
			el = e.target;
			i = 10;

			while (el && i-- > 0) {
				img = checkIMG(el);
				img && bgImages.push(img);

				img = checkBG(el.currentStyle.backgroundImage.match(rgxBgURL));
				img && (bgImages = bgImages.concat(img));

				if (i === 9) {
					el = el.previousElementSibling || el.parentNode;
				}
				else {
					if (el.childElementCount) {
						el = el.lastElementChild;
					}
					else if (el.previousElementSibling) {
						el = el.previousElementSibling;
					}
					else if (el.parentNode) {
						el = el.parentNode.previousElementSibling;
					}
					else {
						el = false;
					}
				}
			}

			// need check
			el = e.target.childElementCount ? e.target.firstElementChild : (e.target.nextElementSibling || e.target.parentNode.nextElementSibling);
			i = 10;

			while (el && i-- > 0) {
				img = checkIMG(el);
				img && bgImages.push(img);

				img = checkBG(el.currentStyle.backgroundImage.match(rgxBgURL));
				img && (bgImages = bgImages.concat(img));

				if (el.childElementCount) {
					el = el.firstElementChild;
				}
				else if (el.nextElementSibling) {
					el = el.nextElementSibling;
				}
				// while el.parentNode.nextElementSibling or not
				else if (el.parentNode && el.parentNode.nextElementSibling) {
					el = el.parentNode.nextElementSibling;
				}
				else {
					el = false;
				}
			}
		}

		if ((e.altKey || elapsed) && !(e.altKey && elapsed)) {
			if (e.target.document instanceof win['SVGDocument']) {
				if (e.target.document.URL !== win.top.location.href) {
					bgImages.push(e.target.document.URL);
				}
			}
			else {
				img = checkIMG(e.target);
				img && bgImages.push(img);
			}
		}

		if ((e.ctrlKey || elapsed) && !(e.ctrlKey && elapsed) && !(e.target.document instanceof win['SVGDocument'])) {
			el = e.target;

			if (el.nodeName == 'HTML') {
				img = checkBG(el.currentStyle.backgroundImage.match(rgxBgURL) || doc.body.currentStyle.backgroundImage.match(rgxBgURL)/*, 'html>body'*/);
				img && (bgImages = bgImages.concat(img));
			}
			else {
				var imgList;//, path = '';

				while(el && el.nodeName !== '#document') {
					//path = path ? el.nodeName + '>' + path : el.nodeName;
					match = el.currentStyle.backgroundImage.match(rgxBgURL);

					if (el.nodeName == 'UL') {
						var f = el.currentStyle.listStyleImage.match(rgxBgURL);
						if (f) {
							if (match) { match.push(f); }
							else { match = f; }
						}
					}

					imgList = checkBG(match/*, path*/);
					imgList && (bgImages = bgImages.concat(imgList));

					el = el.parentNode;
				}
			}
		}

		if (bgImages && bgImages.length > 0) {
			ev.preventDefault();
			e.preventDefault();

			if (!(e.ctrlKey && e.altKey) && !(e.ctrlKey && elapsed)) {
				oex.postMessage({'cmd':'open', 'url': bgImages[0], nf: e.shiftKey});
			}
			else {
				if (bgImages.length > 1) {
					var a = [], l = bgImages.length, j;

					for (i = 0; i < l; ++i) {
						for (j = i + 1; j < l; ++j) {
							if (bgImages[i] == bgImages[j]) {
								j = ++i;
							}
						}

						a.push(bgImages[i]);
					}

					bgImages = a;
				}

				for (i = 0; i < bgImages.length; ++i) {
					oex.postMessage({'cmd':'open', 'url': bgImages[i], nf: e.shiftKey});
				}
			}
		}
	}, false);

	if (!isHTML) { return; }

	var PVI = {
		/*
			link - url regexp
				loop - true, fasle
				attr - if not href attribute wanted
			url - url to resolve
			res - matching regexp for resolve
			useimg - if both present (link, img) then prefer img
			decode - decode URL
			img - image img regexp
			cache
					default is ture - no need to set
					0 - no cache
					1 - will cache the link only
			to - replace to string
			note - info for rule
		*/
		sieve: {
			'dereferers': {
				loop: true,
				decode: true,
				link: /^http:\/\/(?:www\.)?(?:dereferer.org|anonym.to|(?:hiderefer|refblock|ninjarefer)\.com)\/\?(.+)/i, //\.(?:jpe?g|a?png|gif|svgz?|w?bmp)
				to: '$1'
			},
			'facebook_external': {
				loop: true,
				decode: true,
				img: /^https?:\/\/external\.ak\.fbcdn\.net\/safe_image\.php\?d=[\w\-]+&w=\d+&h=\d+&(?:url|src)=([^&]+).*$/,
				to: '$1'
			},
			'facebook': {
				img: /^(https?:\/\/p(?:rofile|hotos-[a-k])\.ak\.fbcdn\.net\/h?p(?:rofile|hotos)-ak-[^\/]+\/(?:(?:\d+_)+|v\d+\/(?:\d+\/)+))[a-mo-z]([\.\d].+)$/,
				to: '$1n$2'
			},
			'WikiMedia': {
				useimg: true,
				attr: 'pathname',
				link: /^\/(?:wiki\/|(?:w\/)?index\.php(?:\?title=|\/))[^:]+:[^\/&]+(?:jpe?g|gif|png|svgz?)/i,
				res: '<div class="fullImageLink" id="file"><a href="([^"]+)">',
				img: /\/thumb\/(\w{1,2}\/\w{1,4}\/[^\/]+\.(?:jpe?g|png|gif|svgz?)).*$/i,
				to: '/$1'
			},
			'IMDb': {
				img: /^(http:\/\/ia\.media-imdb\.com\/images\/M\/[\dA-z@]+\._V1\._).*$/,
				to: '$1SX' + win.screen.availWidth + '_SY' + win.screen.availHeight + '.jpg'
			},
			'Google': {
				cache: 1,
				decode: true,
				link: /^https?:\/\/[^\/]+\.google\.[^\/]+\/imgres\?imgurl=([^&]+).*$/,
				to: '$1'
			},
			'Bing': {
				cache: 1,
				decode: true,
				img: /^http:\/\/ts\d\.[^.]+\.bing\.net\/images\/thumbnail\.aspx\?q=\d+&id=[\da-f]{32}&url=(.+)/,
				to: '$1'
			},
			'yahoo': {
				decode: true,
				link: /^http:\/\/(?:images\.search\.yahoo\.com\/images\/view\?(?:\w+=[^&]+&)*?imgurl=([^&]+)|rds\.yahoo\.com\/\w+=[^;]+;\w+=.+?%26imgurl=(.+?)%26).*$/,
				img: /^http:\/\/sm-a\d\.yimg\.com\/image\/\?url=https?%3A%2F%2F([^&]+)().*$/,
				to: 'http://$1$2'
			},
			'yandex': {
				decode: true,
				link: /^http:\/\/images\.yandex\.[^\/]+\/yandsearch\?.*img_url=([^&]+).*$/,
				to: 'http://$1'
			},
			'flickr': {
				//http://www.flickr.com/services/api/misc.urls.html
				link: /^http:\/\/www\.flickr\.com\/photos\/([^\/]+\/\d+)\/?(?:in\/.+|lightbox\/?|sizes.+|\?.+)?$/,
				url: 'http://www.flickr.com/photos/$1/sizes/o/',
				res: /<img src="(http:\/\/farm\d+\.static\.flickr\.com[^"]+)">/,
				img: /^http:\/\/farm(\d+)\.static\.flickr\.com\/(\d+\/\d+_[\da-z]+)(?:_[stmz])?\.(jpg|gif|png)$/i, //(?:\?[^?]+)?
				to: 'http://farm$1.static.flickr.com/$2_z.$3?zz=1'
				//to: 'http://farm$1.static.flickr.com/$2_b.$3',
				//to: 'http://farm$1.static.flickr.com/$2.$3'
			},
			'deviantArt': {
				img: /^http:\/\/th(\d+\.deviantart\.net\/fs\d+)\/\w+\/(.+\.(?:jpe?g|png|gif|bmp))/i,
				to: 'http://fc$1/$2'
			},
			'Picasa': {
				cache: 1,
				img: /^(https?:\/\/lh\d+\.g(?:oogleusercontent|gpht)\.com\/[_\-](?:[\w\-]{11}\/){4}).+$/,
				to: '$1'
			},
			'youtube': {
				//link: /^http:\/\/(?:www\.youtube\.com\/watch\?v=|youtu.be\/)([\w-]{11}).*$/,
				img: /^http:\/\/i\d.ytimg\.com\/vi\/([\w\-]{11})\/[^0]+\.jpg$/,
				to: 'http://i.ytimg.com/vi/$1/0.jpg'
			},
			'500px': {
				link: /^http:\/\/(?:photos\.)?500px\.com\/(?:photo\/)?(\d+)(?:\/[1-5])?$/,
				img: /^http:\/\/photos\.500px\.com\/(\d+)\/[1-5]$/,
				to: 'http://photos.500px.com/$1/5'
			},
			'fotolog': {
				img: /^(http:\/\/sp[\da-z]\.fotolog\.com\/photo\/(\d+\/){3}[^\/]+\/\d+)_[^f]/,
				to: '$1_f'
			},
			'panoramio': {
				link: /^http:\/\/www\.panoramio\.com\/photo\/(\d+)$/,
				img: /^http:\/\/static\.panoramio\.com\/photos\/iw-thumbnail\/(\d+)\.jpg$/,
				to: 'http://static.panoramio.com/photos/original/$1.jpg'
			},
			'photobucket': {
				useimg: true,
				link: /^http:\/\/media\.photobucket\.com\/image/,
				img: /^http:\/\/th(\w+)\.photobucket\.com\/albums\/(\w+\/(?:[^\/]+\/)+)th_([^\/]+\.(?:jpe?g|png|gif|bmp))$/i,
				to: 'http://i$1.photobucket.com/albums/$2$3'
			},
			'MyOpera': {
				// slower, but better
				//^http:\/\/(?:thumbs|files)\.myopera\.com\/(?:(?:\w+\/h?colx\/)?([^\/]+\/albums\/\d+\/)(?:thumbs\/)?(.+?)(?:_thumb\.jpg)?|(?:\w+\/h?colx\/http:\/\/[^\/]+\/(.+)))$
				img: /^http:\/\/(?:thumbs|files)\.myopera\.com\/(?:(?:\w+\/h?colx\/)?([^\/]+\/(?:albums\/\d+|blog)\/)(?:thumbs\/)?(.+?\.(?:jpe?g|png|bmp|gif))(?:_thumb\.jpg)?|(?:\w+\/\w+\/http:\/\/[^\/]+\/(.+)))$/i,
				to: 'http://files.myopera.com/$1$2$3'
			},
			'Blogspot': {
				link: /^(https?:\/\/(?:\d+\.bp\.blogspot|bp\d\.blogger)\.com\/[_\-](?:[\w\-]{11}\/){4})\w\d+\-h\/(.+)/,
				img: /^(https?:\/\/\d+\.bp\.blogspot\.com\/[_\-](?:[\w\-]{11}\/){4})[^\/]+(.+)/,
				to: '$1s1600$2' //$1
			},
			'imgur': {
				link: /^http(s?):\/\/(?:i\.)?imgur\.com\/+(?!stats|tools)(?:gallery\/|r\/[^\/]+\/)?([\dA-z]{5})\/?(:?\?.*)?$/,
				//url: 'http$1://api.imgur.com/2/image/$2',
				//res: /<original>([^<]+)/
				to: 'http$1://i.imgur.com/$2.png'
			},
			'imageshack': {
				useimg: true,
				link: /^http:\/\/(?:www\.|img\d+\.)?imageshack\.us\/(?:i|photo\/my-images\/\d+)\/[^\/]+\/?$/,
				res: /<link rel="image_src" href="([^"]+)"/,
				img: /^(http:\/\/img\d+.imageshack.us\/img\d+\/\d+\/.+)\.th(\.[^.]+)$/,
				to: '$1$2'
			},
			'yfrog': {
				link: /^http:\/\/(?:www\.)?yfrog\.(?:co(?:m(?:\.pl|\.tr)?|\.il|\.uk)|ru|it|fr|pl|eu)\/([\da-z]{4,12}[jpgbt])$/,
				url: 'http://yfrog.com/api/xmlInfo?path=$1',
				res: /<image_link>([^<]+)/
			},
			'jetscreenshot': {
				link: /^(http:\/\/my\.jetscreenshot\.com\/\d+\/\d{8}-\w+-\d+kb)$/,
				to: '$1.jpg'
			},
			'prntscr': {
				link: /^http:\/\/prntscr\.com\/[\da-z]{5}$/,
				res: /<img class="shot" src='([^']+)'\/>/
			},
			'quickmeme': {
				//useimg: true,
				link: /^http:\/\/(?:www\.quickmeme\.com\/meme|qkme.me)\/(\w+).*/,
				//img: /^http:\/\/t\.qkme\.me\/(\w+)\.jpg$/i,
				to: 'http://i.qkme.me/$1.jpg'
			},
			'weblamers': {
				link: /^http:\/\/(?:www\.)?weblamers\.com\/[\da-z]{5}/,
				res: /<img src='([^']+)'/
			},
			'fotosss': {
				useimg: true,
				link: /^http:\/\/(?:www\.)?fotosss\.com\/pic\/\d+/,
				res: /<input type="text" class="url_box_input" value="(http:\/\/www.fotosss.com\/gallery_images\/[^"]+)"/,
				img: /^http:\/\/www\.fotosss\.com\/sample\d\.php\?nm=([^&]+).*/,
				to: '$1'
			},
			'twitpic': {
				link: /^https?:\/\/(?:www\.)?twitpic\.com\/([\da-z]{5,6})(?:\/full)?$/, // (?:[^.]+\.)?
				to: 'http://twitpic.com/show/full/$1'
			},
			'postimg': {
				link: /^http:\/\/www\.postimg\.com\/image\/(.+)/,
				to: 'http://www.postimg.com/$1'
			},
			'postimage': {
				link: /^http:\/\/(?:www\.)?postimage\.org\/image\/([\da-z]+)\/$/i,
				url: 'http://postimage.org/image/$1/full/',
				res: /<img src='([^']+)' alt='/
			},
			'imgden': {
				link: /^http:\/\/www\.imgden\.com\/\d+\/.+\.(?:jpe?g|png|gif|bmp)$/i,
				res: /var IMAGE_URL='(http:\/\/[^']+)'/
			},
			'webshots': {
				useimg: true,
				link: /^http:\/\/[^\.]+\.webshots\.com\/photo\/(\d+[A-z]+)$/,
				url: 'http://community.webshots.com/photo/fullsize/$1',
				//img: /^http:\/\/(?:thumb|image)\d+\.webshots\.(?:com|net)\/(?:t\/)?(?:\d{1,3}\/){3,5}(\d+[A-z]+)_th.+$/,
				res: /so\.addVariable\('source', '([^']+)'\)/,
				img: /^http:\/\/((?:thumb|image)\d+)\.webshots\.(com|net)\/((?:t\/)?(?:\d{1,3}\/){3,5}\d+[A-z]+_)th(\.[A-z]{3,4})$/,
				to: 'http://$1.webshots.$2/$3ph$4' // fs
			},
			'scrnshots': {
				useimg: true,
				link: /^http:\/\/www\.scrnshots\.com\/users\/[^\/]+\/screenshots\/\d+$/,
				res: /<a href="([^"]+)" rel="lightbox"/,
				img: /^(https?:\/\/s\d\.amazonaws\.com\/scrnshots\.com\/screenshots\/\d+\/.+)_(?:med_rect|small_square|large)(\.(?:png|jpe?g))?$/,
				to: '$1$2'
			},
			'zooomr': {
				useimg: true,
				link: /^http:\/\/www\.zooomr\.com\/photos\/[^\/]+\/(\d+)\/?/,
				url: 'http://www.zooomr.com/z/photos/zoom/$1/size-16/', // 32
				res: /<a href="(http:\/\/static\.zooomr[^"]+)">/,
				img: /^(http:\/\/static\.zooomr\.com\/images\/\d+_[\da-z]+)(?:_[^bo])?(\.[A-z]{3,4})$/,
				to: '$1_b$2' // o
			},
			'23hq': {
				useimg: true,
				link: /^http:\/\/(?:www\.)?23hq\.com\/[^\/]+\/photo\/\d+.*$/,
				res: /<img id="fn_img" src="([^"]+)"/,
				img: /^(http:\/\/(?:www\.)?23hq\.com\/\d+\/\d+_[\da-f]{32}_)(?!large)[^\.]+([A-z]{3,4})$/,
				to: '$1large$2'
			},
			'photo.net': {
				link: /^http:\/\/photo\.net\/photodb\/photo\?photo_id=(\d+)/,
				img: /^http:\/\/thumbs\.photo\.net\/photo\/(\d+)-sm.+/,
				to: 'http://gallery.photo.net/photo/$1-lg.jpg'
			},
			'fotki': {
				img: /^(http:\/\/images\d+\.fotki\.com\/v\d+\/photos\/(?:\d+\/){3}.+)-th\.(jpe?g|png|gif).*$/i,
				to: '$1-vi.$2'
			},
			'ffffound': {
				link: /^http:\/\/ffffound\.com\/image\/([\da-z]{40}).*/,
				img: /^http:\/\/img(?:-thumb)?\.ffffound.com\/static-data\/assets\/\d+\/([\da-z]{40})_(?:m|x?s).*/,
				url: 'http://pix.ie/ellefitz/$1/size/800',
				res: /link-img" href="([^"]+)" target="_blank" onclick="ga_uct/
			},
			'pix.ie': {
				//useimg: true,
				link: /^https?:\/\/pix\.ie\/([^\/]+)\/(\d+)\/?(?:size\/\d+)?/,
				url: 'http://pix.ie/$1/$2/size/1200',
				res: /"><img src="(http:\/\/photos\d(?:\.media)?\.pix\.ie[^"]+)" alt="/,
				img: /^(https?:\/\/photos\d+\.pix\.ie\/(?:[\dA-F]{2}\/){2}[\dA-F]{32})-(?:48|100|160|200|240|500|800)\.([A-z]{3,4})$/, // |1200
				to: '$1-1200.$2'
			},
			'piccsy': {
				link: /^http:\/\/(?:www\.)?piccsy\.com\/\d{4}\/\d{2}\/.+$/,
				res: /<meta property="og:image" content="([^"]+)"/
			},
			'dotphoto': {
				img: /^(https?:\/\/(?:www\.)?dotphoto\.com\/SAN1\/(?:[\dA-F]{2}\/){3})[^i]([\dA-F]{8}-[\dA-F]{4}-[\dA-F]{4}-[\dA-F]{4}-[\dA-F]{12}\.[A-z]{3,4})$/,
				to: '$1i$2'
			},
			'woophy': {
				link: /^http:\/\/(?:www\.)?woophy\.com\/photo\/(\d+).*$/,
				url: 'http://www.woophy.com/download/$1',
				res: /<img id="photo_enlarged" src="([^"]+)"/ // need to fix if not on the same domain
			},
			'pbase': {
				//useimg: true,
				link: /^http:\/\/www\.pbase\.com\/([^\/]+)\/image\/(\d+).*$/,
				url: 'http://www.pbase.com/$1/image/$2/original',
				res: /<IMG class="display" src="([^"]+)"/,
				img: /^(http:\/\/ic?\d?\.pbase\.com\/)[^o](\d\/\d+\/\d+)\/[234]\/(\d+.+)$/,
				to: '$1g$2/3/$3'
			},
			'ipernity': {
				link: /^http:\/\/www\.ipernity\.com\/doc\/([^\/]+\/\d+).*$/,
				url: 'http://www.ipernity.com/doc/$1/sizes/1024',
				res: /<img src="(http:\/\/u\d\.ipernity\.com\/\d+\/[^"]+)"/
			},
			'koffeephoto': {
				link: /^http:\/\/www\.koffeephoto\.com\/album\/([\w\-]{24})\/(\d+).*$/,
				img: /^http:\/\/mediascache\.koffeephoto\.com\/([\w\-]{24})\/thumbnails\/\d+\/(\d+)\/photo\.jpg.*$/,
				to: 'http://mediascache.koffeephoto.com/$1/thumbnails/1024/$2/photo.jpg?v=0'
			},
			'weheartit': {
				img: /^(http:\/\/data\.whicdn\.com\/images\/\d+\/.+_)(?:tiny|thumb)(\.[A-z]{3,4}\?\d{10})$/,
				to: '$1large$2'
			},
			'aminus3': {
				img: /^(https?:\/\/(?:aminus3\.s\d\.amazonaws|img\.aminus2)\.com\/image\/g\d+\/u\d+\/i\d+\/[\da-f]{32}_)(?!large)[^\.]+(.+)/,
				to: '$1large$2'
			},
			'pixagogo': {
				link: /^https?:\/\/(?:www\.)?pixagogo\.com\/Photos\/Albums\/Photo\.aspx\?id=[\w\-!]+/,
				res: /<td align="center"><IMG border=0 src="([^"]+)"/
			},
			'artlimited': {
				img: /^(http:\/\/(?:www\.|\d+\.portfolio\.)?artlimited\.net\/+(?:user\/(?:\d\/){7}|picbase\/news\/)[^\/]+)_[sm](\.[a-z]{3,4})$/,
				to: '$1$2'
			},
			'humblevoice': {
				img: /^(https?:\/\/www\.humblevoice\.com\/user_uploads\/profile(?:_gallery_)?images)\/\d+_\d+\/[^\/]+\/(.+)/,
				to: '$1/$2'
			},
			'imageevent': {
				img: /^(http:\/\/photos\.imageevent\.com\/(?:[^\/]+\/)+?)(?:icons|small|websize)\/(.+)/,
				to: '$1/$2' // large
			},
			'photosig': {
				link: /^http:\/\/www\.photosig\.com\/go\/photos\/view[\?;].+/,
				res: /<img src="(http:\/\/photos\.photosig\.com\/photos\/\d+\/\d+\/\d+\-[\da-f][^"]+)" width="/
			},
			'gotsmile': {
				img: /^(http:\/\/s\d.static.gotsmile.net\/images)\/thumbs\/(\d{4}\/\d{2}\/\d{2}\/.+)$/,
				to: '$1/$2'
			},
			'redbubble': {
				img: /^http:\/\/ih(\d\.redbubble\.net\/work\.\d+\.\d+\.[^,]+),\d*x\d\d*,(.+)/,
				to: 'http://ih$1,800x800,$2'
			},
			'demotivators.us': {
				link: /^http:\/\/demotivators\.us\/\d+\/[\w\-]+/,
				res: /<meta property="og:image" content="([^"]+)"/
			},
			'kepfeltoltes.hu': {
				link: /^http:\/\/(?:wwww\.)?kepfeltoltes\.hu\/view\/(\d+)\/(.+)/,
				to: 'http://kepfeltoltes.hu/$1/$2'
			},
			'kephost.com': {
				link: /^http:\/\/(?:www\.)?kephost.com\/\w+\.php\?filename=\w+\.[A-z]+$/,
				res: /"><img src="([^"]+)" alt="/
			},
			'kephost.hu': {
				link: /^http:\/\/(?:www\.)?kephost.hu\/index\.php\?m=kepek&f=\d+$/,
				res: /<a href="(.+)" rel="lightbox">/
			},
			'LinkedImages': {
				attr: 'pathname',
				link: rgxObjImg
			}
		},
		PrevDIV: null,
		target: null,
		img: null,
		imageStack: {},
		collectxy: false,
		xy: [],
		timers: {imload: null, preview: null},
		resolving: {counter: 0, data: {}},
		anim: {},
		create: function () {
			if (PVI.PrevDIV) { return; }

			root || (root = doc.documentElement);
			PVI.PrevDIV = doc.createElement('DIV');

			var bg = '';

			if (PVI.cfg['background']) {
				if (PVI.cfg['background'] == 'cb') {
					bg = ';background-color:rgba(0,0,0,0);background-image:url(data:image/gif;base64,R0lGODlhFAAUAPABAOjo6P///yH5BAAKAAAALAAAAAAUABQAAAIohI+hy+jAYnhJLnrsxVBP7n1YyHVaSYKhh7Lq+VotPLo1TaW3HEtlAQA7)';
				}
				else if (/^(?:http|-o-skin)/i.test(PVI.cfg['background'])) { bg = ';background-color:rgba(0,0,0,0);background-image:url(' + PVI.cfg['background'] + ')'; }
				else { bg = ';background-color:' + PVI.cfg['background']; }

				bg += ';background-clip:content-box';
			}

			PVI.PrevDIV.style.cssText = 'position:fixed;z-index:2147483646;left:auto;top:auto;right:auto;bottom:auto;font-size:9pt;font-family:Verdana;color:#000' + bg + (PVI.cfg['shadow'] ? ';box-shadow:' + PVI.cfg['shadow'] : '') + (PVI.cfg['border'] ? ';border:' + PVI.cfg['border'] : '') + (PVI.cfg['fade'] ? ';opacity:0' : '');

			PVI.PrevDIV.outsize = 2 * (PVI.cfg['margin'] + (PVI.cfg['border'] ? parseInt(PVI.PrevDIV.style.borderWidth, 10) + 1 : 0));

			PVI.PrevDIV.innerHTML = '<object data="data:image/gif;" style="width:auto;height:auto;margin:0;-o-object-fit:contain' + (PVI.cfg['border'] ? ';border:1px solid #bbb' : '') + '" type="image/jpeg"></object>' +
			//'<div style="position:absolute;top:0;right:0;background-color:rgba(0,0,0,0.2);color:#fff">' +
			//'<div>rotate left right</div><div>flipv flipH</div><div>upload</div><div>zoom-zoom</div></div>' +
			'<div style="position:absolute;top:-1em;left:5px;white-space:nowrap;background-color:#fff;padding:0 5px;border-radius:4px;color:#000"></div>';

/*
			PVI.PrevDIV.style.cssText = 'position:fixed;z-index:2147483646;left:auto;top:auto;right:auto;bottom:auto;font-size:9pt;font-family:Verdana;color:#000';

			PVI.PrevDIV.innerHTML = '<object data="" style="width:auto;height:auto;margin:0' + (PVI.cfg['sizing'] ? ';-o-transition:max-width '+PVI.cfg['sizing']+'ms, max-height '+PVI.cfg['sizing']+'ms' : '') + bg + (PVI.cfg['shadow'] ? ';box-shadow:' + PVI.cfg['shadow'] : '') + (PVI.cfg['border'] ? ';border:' + PVI.cfg['border'] + ';background-clip:padding-box' : '') + '"></object><div style="position:absolute;top:-0.5em;left:5px;white-space:nowrap;background-color:#fff;padding:0 5px;border-radius:4px"></div>';
*/
			PVI.anim.container = [];

			if (PVI.cfg['fade']) {
				PVI.anim.container.push('opacity ' + PVI.cfg['fade'] + 'ms');
				PVI.PrevDIV.addEventListener('oTransitionEnd', function () {
					if (!PVI.fullZoom && this.style.display == 'block' && this.style.opacity == '0') {
						PVI.reset();
					}
				}, false);
			}

			if (PVI.cfg['position']) {
				PVI.anim.container.push(['top', 'right', 'bottom', 'left'].join(' ' + PVI.cfg['position'] + 'ms, ') + ' ' + PVI.cfg['position'] + 'ms');

				!PVI.cfg['fade'] && PVI.PrevDIV.addEventListener('oTransitionEnd', function () {
					if (!PVI.fullZoom && this.style.display == 'block' && (parseInt(this.style.left, 10) < 0 || parseInt(this.style.right, 10) < 0)) {
						PVI.reset();
					}
				}, false);
			}

			if (PVI.cfg['sizing']) {
				PVI.PrevDIV.firstChild.style['OTransition'] = PVI.anim.obj = 'max-width ' + PVI.cfg['sizing'] + 'ms, max-height ' + PVI.cfg['sizing'] + 'ms';
				PVI.PrevDIV.firstChild.addEventListener('oTransitionEnd', function () {
					if (!PVI.fullZoom && PVI.PrevDIV.style.display == 'block' && this.style.maxWidth == '0px') {
						PVI.reset();
					}
				}, false);
			}

			if (PVI.anim.container.length) { PVI.PrevDIV.style['OTransition'] = PVI.anim.container = PVI.anim.container.join(', '); }

			PVI.height_helper = doc.createElement('DIV');
			PVI.height_helper.style.cssText = 'position:absolute;top:0;z-index:-666;height:100%;width:0';
			root.appendChild(PVI.height_helper);

			root.appendChild(PVI.PrevDIV);
			PVI.reset();
		},
		resolve: function (URL, res) {
			if (win.location.href.replace(rgxRemHash, '') == URL.replace(rgxRemHash, '')) { return false; } // maybe not the best idea
			//if (1) {} // check if url already resolved

			clearTimeout(PVI.timers.imload);

			PVI.timers.imload = setTimeout(function (){
				PVI.resolving.data[++PVI.resolving.counter] = PVI.target;
				oex.postMessage({'cmd': 'resolve', 'url': URL, 'find': res, 'id': PVI.resolving.counter});
			}, PVI.cfg['hoverTime'])

			return true;
		},
		find: function (tt) {
			var i = 0, n = tt || PVI.target, ret = false, sieve, sn, imgSRC, found;

			if (PVI.target.imagus_sieve_cache) {
				sieve = {};
				sieve[PVI.target.imagus_sieve_cache] = PVI.sieve[PVI.target.imagus_sieve_cache];
			}
			else {
				sieve = PVI.sieve;
			}

			do {
				if (n.href) {
					if (PVI.target.src && n.href == PVI.target.src || win.location.href.replace(rgxRemHash, '') == n.href.replace(rgxRemHash, '')) { break; }

					for (sn in sieve) {
						if (sieve[sn].link && sieve[sn].link.test(n[sieve[sn].attr || 'href'])) {
							if (sieve[sn].useimg && sieve[sn].img) {
								if (!imgSRC) {
									if (PVI.target.nodeName == 'IMG') { imgSRC = PVI.target.src; }
									else if (PVI.target.currentStyle.backgroundImage !== 'none') { imgSRC = PVI.target.currentStyle.backgroundImage.match(rgxBgURL); }
									if (imgSRC instanceof Array) { imgSRC = imgSRC[0].slice(1, -1); }
								}

								if (imgSRC && sieve[sn].img.test(imgSRC)) {
									found = true;

									if (!PVI.target.imagus_sieve_cache) {
										sieve = {};
										sieve[sn] = PVI.sieve[sn];
									}

									break;
								}
							}

							if (sieve[sn].res && PVI.resolve((sieve[sn].url ? n.href.replace(sieve[sn].link, sieve[sn].url) : n.href), sieve[sn].res)) {
								ret = null;
								break;
							}

							ret = sieve[sn].to ? n.href.replace(sieve[sn].link, sieve[sn].to) : n.href;
							sieve[sn].decode && (ret = decodeURIComponent(decodeURIComponent(ret)));

							if (sieve[sn].loop) {
								ret = PVI.find({href: ret});
							}

							break;
						}
					}

					break;
				}
			} while (++i < 10 && (n = n.parentNode));

			if (!tt) {
				if (!ret && ret !== null) {
					if (!imgSRC) {
						if (PVI.target.nodeName == 'IMG') { imgSRC = PVI.target.src; }
						else if (PVI.target.currentStyle.backgroundImage !== 'none') { imgSRC = PVI.target.currentStyle.backgroundImage.match(rgxBgURL); }
						if (imgSRC instanceof Array) { found = null; imgSRC = imgSRC[0].slice(1, -1); }
					}

					if (imgSRC) {
						for (sn in sieve) {
							if (found == true || (sieve[sn].img && sieve[sn].img.test(imgSRC))) {
								if (!sieve[sn].to && sieve[sn].res && sieve[sn].url && PVI.resolve(imgSRC.replace(sieve[sn].img, sieve[sn].url), sieve[sn].res)) {
									ret = null;
								}
								else {
									ret = sieve[sn].to ? imgSRC.replace(sieve[sn].img, sieve[sn].to) : imgSRC;
									sieve[sn].decode && (ret = decodeURIComponent(ret));
								}

								found = PVI.target.src ? true : false;
								break;
							}
						}

						if (found === null) { found = false; }

						if (ret && !found && PVI.cfg['zoomResized']) { PVI.target.imagus_thumb = true; }
					}
				}

				if ((imgSRC && imgSRC === ret) || (PVI.target.src && ret == PVI.target.src)) { ret = false; }

				if (!ret && ret !== null && PVI.cfg['zoomResized'] && PVI.target.src && (PVI.target.naturalWidth - PVI.cfg['zoomResized'] > PVI.target.clientWidth || PVI.target.naturalHeight - PVI.cfg['zoomResized'] > PVI.target.clientHeight) && PVI.target.clientWidth <= win.innerWidth && PVI.target.clientHeight <= win.innerHeight) {
					ret = PVI.target.src;
				}

				ret && (ret = ret.replace(/#/g, '%23'));
			}

			if (ret || ret === null) {
				if (!tt) {
					n = PVI.target;

					do {
						if (n.title != '') {
							if (PVI.cfg['caption'] && !PVI.target.imagus_title) {
								PVI.target.imagus_title = n.title;
							}

							n.title = '';
						}
					} while ((n = n.parentNode) && n.nodeName !== 'HTML');

					if (PVI.cfg['caption'] && !PVI.target.imagus_title && PVI.target.alt) {
						PVI.caption_helper.innerHTML = PVI.target.alt.replace(/(?:\n|\r\n?)+/g, ' ').replace(/</g, '&lt;');
						PVI.target.imagus_title = PVI.caption_helper.innerText;
					}

					if (ret && rgxIsSVG.test(ret)) {
						PVI.target.imagus_SVG = true;
					}
				}

				(sieve[sn].cache === 1) && (PVI.target.imagus_sieve_cache || (PVI.target.imagus_sieve_cache = sn));
			}

			return ret;
		},
		show: function (pre) {
			!PVI.cfg['move'] && (PVI.collectxy = false);

			if (PVI.hiding) {
				if (PVI.cfg['waitHide']) {
					return;
				}

				PVI.hiding = false;

				if (!PVI.target.imagus_cache) {
					delete PVI.PrevDIV.firstChild.data;
					PVI.PrevDIV.firstChild.innerText = 'Loddig...';
				}
			}
			else /*if (PVI.PrevDIV.style.display !== 'block') */{
				PVI.PrevDIV.style.display = 'block';
				PVI.cfg['fade'] && (PVI.PrevDIV.style.opacity = '1');
				PVI.cfg['position'] && !pre && PVI.show(true);
			}

			var winW = Math.max(doc.body.clientWidth, root.clientWidth),
					winH,
					left, top, bottom, right;

			(winW > win.innerWidth) && (winW = win.innerWidth);
			//winH = win.innerHeight - ( winW < Math.max(doc.body.scrollWidth, root.scrollWidth) ? win.innerWidth - winW : 0);
			winH = PVI.height_helper.clientHeight;

			if (PVI.cfg['placement'] === 2) {
				left = PVI.xy[0];
				top = PVI.xy[1];
			}
			else {
				// maybe TODO: use only left-top

				var rSide = winW - PVI.xy[0], bSide = winH - PVI.xy[1];

				if (PVI.xy[0] < rSide) {
					left = PVI.xy[0];
					PVI.PrevDIV.style.right = 'auto';
				}
				else {
					right = rSide;
					PVI.PrevDIV.style.left = 'auto';
				}

				if (PVI.xy[1] < bSide) {
					top = PVI.xy[1];
					PVI.PrevDIV.style.bottom = 'auto';
				}
				else {
					bottom = bSide;
					PVI.PrevDIV.style.top = 'auto';
				}
			}

			if (!pre && PVI.target.imagus_cache) {
				var wo = PVI.imageStack[PVI.target.imagus_cache][0], ho = PVI.imageStack[PVI.target.imagus_cache][1], w, h, vAreaFill, hAreaFill, ratio = wo / ho;

				w = wo + PVI.PrevDIV.outsize;
				h = w / ratio;

				if (PVI.cfg['placement'] === 2) {
					PVI.PrevDIV.style.right = PVI.PrevDIV.style.bottom = 'auto';

					w = Math.min(w, winW);
					h = Math.min(h, winH);

					left = parseInt((winW - w) / 2, 10);
					top = parseInt((winH - h) / 2, 10);
					right = bottom = undefined;
				}
				else {
					w = Math.min(w, winW);
					h = Math.min(h, winH);

					if (top) { hAreaFill = bSide; }
					else { hAreaFill = PVI.xy[1]; }

					hAreaFill = ratio > winW / hAreaFill ? winW : hAreaFill * ratio;

					if (left) { vAreaFill = rSide; }
					else { vAreaFill = PVI.xy[0]; }

					vAreaFill = ratio > vAreaFill / winH ? vAreaFill : winH * ratio;

					if (left && top) {
						if (hAreaFill > vAreaFill) {
							h = Math.min(h, bSide);
							if (PVI.cfg['placement'] === 1) { left = Math.max(0, PVI.xy[0] - ratio * h / 2); }
							else { left -= Math.max(0, w - rSide); }
						}
						else {
							w = Math.min(w, rSide);
							if (PVI.cfg['placement'] === 1) { top = Math.max(0, PVI.xy[1] - w / ratio / 2); }
							else { top -= Math.max(0, h - bSide); }
						}
					}

					if (right && top) {
						if (hAreaFill > vAreaFill) {
							h = Math.min(h, bSide);
							if (PVI.cfg['placement'] === 1) { right = Math.max(0, rSide - ratio * h / 2); }
							else { right -= Math.max(0, w - PVI.xy[0]); }
						}
						else {
							w = Math.min(w, PVI.xy[0]);
							if (PVI.cfg['placement'] === 1) { top = Math.max(0, PVI.xy[1] - w / ratio / 2); }
							else { top -= Math.max(0, h - bSide); }
						}
					}

					if (left && bottom) {
						if (hAreaFill > vAreaFill) {
							h = Math.min(h, PVI.xy[1]);
							if (PVI.cfg['placement'] === 1) { left = Math.max(0, PVI.xy[0] - ratio * h / 2); }
							else { left -= Math.max(0, w - rSide); }
						}
						else {
							w = Math.min(w, rSide);
							if (PVI.cfg['placement'] === 1) { bottom = Math.max(0, bSide - w / ratio / 2); }
							else { bottom -= Math.max(0, h - PVI.xy[1]); }
						}
					}

					if (right && bottom) {
						if (hAreaFill > vAreaFill) {
							h = Math.min(h, PVI.xy[1]);
							if (PVI.cfg['placement'] === 1) { right = Math.max(0, rSide - ratio * h / 2); }
							else { right -= Math.max(0, w - PVI.xy[0]); }
						}
						else {
							w = Math.min(w, PVI.xy[0]);
							if (PVI.cfg['placement'] === 1) { bottom = Math.max(0, bSide - w / ratio / 2); }
							else { bottom -= Math.max(0, h - PVI.xy[1]); }
						}
					}
				}
			}

			top === undefined || (PVI.PrevDIV.style.top = top + PVI.cfg['margin'] + 'px');
			left === undefined || (PVI.PrevDIV.style.left = left + PVI.cfg['margin'] + 'px');
			bottom === undefined || (PVI.PrevDIV.style.bottom = bottom + PVI.cfg['margin'] + 'px');
			right === undefined || (PVI.PrevDIV.style.right = right + PVI.cfg['margin'] + 'px');

			if (!pre && PVI.target.imagus_cache) {
				if (PVI.target.imagus_SVG) {
					if (w / h > wo / ho) { w = ratio * h; }
					else { h = w / ratio; }

					PVI.PrevDIV.firstChild.style.width = w - PVI.PrevDIV.outsize + 'px';
					PVI.PrevDIV.firstChild.style.height = h - PVI.PrevDIV.outsize + 'px';
				}
				else if (PVI.PrevDIV.firstChild.style.width !== 'auto') {
					PVI.PrevDIV.firstChild.style.width = PVI.PrevDIV.firstChild.style.height = 'auto';
				}

				PVI.PrevDIV.firstChild.style.maxWidth = w - PVI.PrevDIV.outsize + 'px';
				PVI.PrevDIV.firstChild.style.maxHeight = h - PVI.PrevDIV.outsize + 'px';

				PVI.cfg['caption'] && (PVI.PrevDIV.lastChild.innerText = PVI.target.imagus_title || '');// + ' ' + PVI.PrevDIV.firstChild.clientWidth + 'x' + PVI.PrevDIV.firstChild.clientHeight;
			}
		},
		hide: function (ev) {
			ev.event && (ev = ev.event);
			PVI.collectxy = false;

			PVI.cfg['outline'] && ((ev.target.origOutline === undefined) || (ev.target.style.outline = ev.target.origOutline));

			clearInterval(PVI.timers.preview);
			clearInterval(PVI.timers.imload);

			if (PVI.fullZoom || (PVI.cfg['deactivate'] && ev[PVI.cfg['act_trigger'] + 'Key'])) { return; }

			if (!PVI.hiding && PVI.PrevDIV && PVI.PrevDIV.style.display == 'block') {
				if (PVI.PrevDIV.lastChild.nodeName == 'OBJECT') {
					PVI.PrevDIV.removeChild(PVI.PrevDIV.lastChild);
				}

				PVI.hiding = true;
				PVI.PrevDIV.lastChild.innerText = '';
				var onlypos = !PVI.cfg['sizing'] && !PVI.cfg['fade'];

				if (onlypos || (PVI.cfg['position'] && PVI.cfg['follow'])) {
					if (onlypos) {
						var winW = Math.max(doc.body.clientWidth, root.clientWidth);
						(winW > win.innerWidth) && (winW = win.innerWidth);
					}

					if (!onlypos) {
						if (PVI.PrevDIV.style.top !== 'auto') {
							PVI.PrevDIV.style.top = ev.clientY + 'px';
						}
						else if (PVI.PrevDIV.style.bottom !== 'auto') {
							PVI.PrevDIV.style.bottom = win.innerHeight - ev.clientY + 'px';
						}
					}

					if (PVI.PrevDIV.style.right !== 'auto') {
						PVI.PrevDIV.style.right = (onlypos ? - ev.clientX - 30: doc.body.clientWidth - ev.clientX) + 'px';
					}
					else if (PVI.PrevDIV.style.left !== 'auto') {
						PVI.PrevDIV.style.left = (onlypos ? - winW + ev.clientX - 30 : ev.clientX) + 'px';
					}
				}

				if (PVI.cfg['sizing']) {
					PVI.PrevDIV.firstChild.style.maxWidth = '0px';
					PVI.PrevDIV.firstChild.style.maxHeight = '0px';
				}

				PVI.cfg['fade'] && (PVI.PrevDIV.style.opacity = '0');
				onlypos && !PVI.cfg['position'] && PVI.reset();
			}
		},
		set: function (src) {
			clearInterval(PVI.timers.imload);
			PVI.create();

			if (PVI.target.imagus_SVG || rgxIsSVG.test(src)) {
				PVI.target.imagus_SVG || (PVI.target.imagus_SVG = true);
				PVI.PrevDIV.firstChild.style.maxWidth = PVI.PrevDIV.firstChild.style.maxHeight = '';
				PVI.PrevDIV.firstChild.innerText = 'Loddig SVG...';

				if (PVI.PrevDIV.lastChild.nodeName == 'OBJECT') {
					PVI.PrevDIV.lastChild.data = src + '#IMAGUS_SVG_GET';
				}
				else {
					var svg_obj = doc.createElement('OBJECT');
					svg_obj.style.cssText = 'width:0;height:0';
					svg_obj.data = src + '#IMAGUS_SVG_GET';
					PVI.PrevDIV.appendChild(svg_obj);
				}

				clearInterval(PVI.timers.imload);
				PVI.timers.imload = setTimeout(function () {
					PVI.PrevDIV.firstChild.innerText = 'Timmo!';
					PVI.PrevDIV.removeChild(svg_obj);
				}, PVI.cfg['timeout']);
				PVI.show();
				return;
			}

			PVI.img = new Image();
			PVI.img.onerror = function (x) {
				clearInterval(PVI.timers.imload);

				//if (x !== true) { PVI.target.imagus_cache = true; }

				//this.src = '';
				PVI.PrevDIV.firstChild.innerText = (x === true ? 'Timmo!' : 'Erray!');
				throw null;
			};

			PVI.img.src = src;


			if (PVI.img.naturalWidth) {
				if (PVI.target.imagus_thumb && (PVI.img.naturalWidth - PVI.cfg['zoomResized'] < PVI.target.width || PVI.img.naturalHeight - PVI.cfg['zoomResized'] < PVI.target.clientHeight)) {
					delete PVI.target.imagus_thumb;
					PVI.target.imagus_cache = true;
					PVI.cfg['outline'] && (PVI.target.style.outline = '1px solid purple');
					return;
				}

				PVI.PrevDIV.firstChild.data = PVI.target.imagus_cache = src;
				PVI.imageStack[src] = [PVI.img.naturalWidth, PVI.img.naturalHeight];
				PVI.show();
				return;
			}

			PVI.PrevDIV.firstChild.style.maxWidth = PVI.PrevDIV.firstChild.style.maxHeight = '';
			PVI.PrevDIV.firstChild.innerText = 'Loddig...';
			PVI.show();

			var startTime = Date.now();

			PVI.timers.imload = setInterval(function () {
				if (PVI.img.naturalWidth && PVI.img.naturalHeight) {
					clearInterval(PVI.timers.imload);

					if (PVI.target.imagus_thumb && (PVI.img.naturalWidth - PVI.cfg['zoomResized'] < PVI.target.width || PVI.img.naturalHeight - PVI.cfg['zoomResized'] < PVI.target.clientHeight)) {
						PVI.PrevDIV.firstChild.innerText = 'Nopee...';
						delete PVI.target.imagus_thumb;
						PVI.target.imagus_cache = true;
						PVI.cfg['outline'] && (PVI.target.style.outline = '1px solid purple');
						return;
					}

					PVI.PrevDIV.firstChild.data = PVI.target.imagus_cache = src;
					PVI.imageStack[src] = [PVI.img.naturalWidth, PVI.img.naturalHeight];
					PVI.show();
					return;
				}

				if (Date.now() - startTime > PVI.cfg['timeout']) {
					PVI.img.onerror(true);
				}
			}, PVI.cfg['checkInterval']);
		},
		reset: function () {
			PVI.PrevDIV.style.display = 'none';
			if (PVI.cfg['sizing']) {
				PVI.PrevDIV.firstChild.style.maxWidth = '0px';
				PVI.PrevDIV.firstChild.style.maxHeight = '0px';
			}
			PVI.PrevDIV.style.top = PVI.PrevDIV.style.bottom = PVI.PrevDIV.style.right = PVI.PrevDIV.style.left = 'auto';
			PVI.cfg['fade'] && (PVI.PrevDIV.style.opacity = '0');
			delete PVI.PrevDIV.firstChild.data;
			PVI.PrevDIV.firstChild.innerText = PVI.PrevDIV.lastChild.innerText = '';
			PVI.hiding = false;

			if (PVI.fullZoom) {
				PVI.fullZoom = false;
				PVI.PrevDIV.style['OTransition'] = PVI.anim.container;
				PVI.PrevDIV.firstChild.style['OTransition'] = PVI.anim.obj;
				PVI.PrevDIV.firstChild.style.width = PVI.PrevDIV.firstChild.style.height = 'auto';
			}

			doc.removeEventListener('keydown', PVI.full_zoom, false);
		},
		full_zoom: function (ev) {
			if (ev.keyCode === 90) {
				ev.preventDefault();

				if (PVI.fullZoom) {
					PVI.reset();
					return;
				}

				var
					w = PVI.imageStack[PVI.target.imagus_cache][0],
					h = PVI.imageStack[PVI.target.imagus_cache][1],
					ratio = w / h,
					winW = Math.max(doc.body.clientWidth, root.clientWidth),
					winH;

				w += PVI.PrevDIV.outsize / 2;
				h = w / ratio;

				(winW > win.innerWidth) && (winW = win.innerWidth);
				//winH = win.innerHeight - ( winW < Math.max(doc.body.scrollWidth, root.scrollWidth) ? win.innerWidth - winW : 0);
				winH = PVI.height_helper.clientHeight;

				PVI.PrevDIV.style['OTransition'] = 'all 0';
				PVI.PrevDIV.firstChild.style['OTransition'] = 'all 0';

				if (PVI.target.imagus_SVG) { PVI.PrevDIV.firstChild.style.maxWidth = PVI.PrevDIV.firstChild.style.maxHeight = '100%'; }
				else { PVI.PrevDIV.firstChild.style.maxWidth = PVI.PrevDIV.firstChild.style.maxHeight = 'none'; }

				PVI.PrevDIV.style.right = PVI.PrevDIV.style.bottom = 'auto';
				PVI.PrevDIV.style.left = parseInt((winW - w) / 2, 10) + 'px';
				PVI.PrevDIV.style.top = parseInt((winH - h) / 2, 10) + 'px';

				PVI.fullZoom = true;
			}
		},
		m_over: function (ev) {
			if ((!PVI.cfg['deactivate'] && PVI.cfg['act_trigger'] && !ev.event[PVI.cfg['act_trigger'] + 'Key']) ||
					(PVI.cfg['deactivate'] && (!PVI.cfg['act_trigger'] || ev.event[PVI.cfg['act_trigger'] + 'Key'])) ||
					PVI.fullZoom) { return; }

			PVI.target = ev.event.target;
			var imgsrc, cache = (PVI.target.imagus_cache && !PVI.target.imagus_sieve_cache);

			if (PVI.target.imagus_cache === true) { return; }

			if (!PVI.target.imagus_sieve_cache && typeof PVI.target.imagus_cache_resolved == 'string') {
				imgsrc = PVI.target.imagus_cache_resolved;
				cache = false;
			}

			if (cache || (imgsrc = imgsrc || PVI.find()) || imgsrc === null) {
				if (imgsrc && !PVI.target.imagus_cache_resolved) {
					if (PVI.cfg['preload'] && PVI.cfg['hoverTime'] > 100 && !PVI.imageStack[imgsrc]) {
						new Image().src = imgsrc;
						PVI.imageStack[imgsrc] = true;
					}

					PVI.target.imagus_cache_resolved = imgsrc;
				}

				PVI.collectxy = true;

				if (PVI.cfg['outline']) {
					(typeof PVI.target.origOutline == 'string') || (PVI.target.origOutline = PVI.target.style.outline);
					PVI.target.style.outline = '1px solid ' + (PVI.target.imagus_SVG ? 'blue' : 'red');
				}

				PVI.timers.preview = setTimeout(function () {
					PVI.cfg['hideOnScroll'] && doc.addEventListener('scroll', PVI.hideOnScrollFunc, false);
					doc.addEventListener('keydown', PVI.full_zoom, false);
					PVI.cfg['outline'] && (PVI.target.style.outline = '0');
					(PVI.target.imagus_cache_resolved === true) || (PVI.target.imagus_cache_resolved = true);

					if (imgsrc === null) {
						PVI.create();
						PVI.PrevDIV.firstChild.innerText = 'Resova...';
						PVI.show();
						return;
					}

					if (cache || PVI.imageStack[imgsrc] instanceof Array) {
						PVI.create();
						delete PVI.PrevDIV.firstChild.data;
						PVI.PrevDIV.firstChild.data = cache ? PVI.target.imagus_cache : (PVI.target.imagus_cache = imgsrc);
						PVI.show();
						return;
					}

					PVI.set(imgsrc);
				}, PVI.hiding ? (PVI.cfg['waitHide'] ? Math.max(PVI.cfg['fade'], PVI.cfg['sizing'], PVI.cfg['position']) + 100 : 0) : PVI.cfg['hoverTime']);
			}
			else {
				PVI.target.imagus_cache = true;
			}
		},
		m_move: function (ev) {
			if (PVI.fullZoom) {
				var xy,
					w = PVI.imageStack[PVI.target.imagus_cache][0],
					h = PVI.imageStack[PVI.target.imagus_cache][1],
					ratio = w / h,
					winW = Math.max(doc.body.clientWidth, root.clientWidth),
					winH;

				w += PVI.PrevDIV.outsize / 2;
				h = w / ratio;

				(winW > win.innerWidth) && (winW = win.innerWidth);
				//winH = win.innerHeight - ( winW < Math.max(doc.body.scrollWidth, root.scrollWidth) ? win.innerWidth - winW : 0);
				winH = PVI.height_helper.clientHeight;

				if (w > winW) {
					xy = ev.event.clientX * (w - winW + 80) / winW;
					PVI.PrevDIV.style.left = -xy + 50 + 'px';
				}
				else {
					PVI.PrevDIV.style.left = (winW - w) / 2 + 'px';
				}

				if (h > winH) {
					xy = ev.event.clientY * (h - winH + 80) / winH;
					PVI.PrevDIV.style.top = -xy + 50 + 'px';
				}
				else {
					PVI.PrevDIV.style.top = (winH - h) / 2 + 'px';
				}

				return;
			}

			if (PVI.collectxy/* && (!PVI.cfg['deactivate'] && ev[PVI.cfg['act_trigger'] + 'Key'])*/) {
				PVI.xy[0] = ev.event.clientX;
				PVI.xy[1] = ev.event.clientY;

				if ((!PVI.cfg['deactivate'] && PVI.cfg['act_trigger'] && !ev.event[PVI.cfg['act_trigger'] + 'Key']) || (PVI.cfg['deactivate'] && (!PVI.cfg['act_trigger'] || ev.event[PVI.cfg['act_trigger'] + 'Key']))) { return; }
				else if (PVI.cfg['placement'] < 2 && !PVI.hiding && PVI.cfg['move'] && PVI.PrevDIV && PVI.PrevDIV.style.display == 'block') {
					PVI.show();
				}
			}
		},
		hideOnScrollFunc: function () {
			//if (PVI.fullZoom) { return; }
			PVI.reset();
			doc.removeEventListener('scroll', PVI.hideOnScrollFunc, false);
		},
		onMessage: function (e) {
			if (!e.data) { return; }
			PVI.create();

			if (e.data['cmd'] == 'resolved') {
				if (!e.data['m']) {
					PVI.PrevDIV.firstChild.innerText = 'Faila...';
				}
				else if (PVI.resolving.data[e.data.id] === PVI.target) {
					PVI.set(e.data['m']);
					PVI.resolving.data[e.data.id].imagus_cache_resolved = true;
				}
				else {
					/*if (PVI.cfg['preload'] && PVI.cfg['hoverTime'] > 100 && !PVI.imageStack[e.data.m]) {
						new Image().src = e.data.m;
						PVI.imageStack[e.data.m] = true;
					}*/

					PVI.resolving.data[e.data.id].imagus_cache_resolved = e.data['m'];
				}
			}
			else if (e.data['cmd'] == 'svg_info') {
				var url = e.data['url'].replace('#IMAGUS_SVG_GET', '#IMAGUS_SVG');

				if (!e.data['svg']) {
					PVI.PrevDIV.firstChild.innerText = 'Erray! no SVG...';
					return;
				}

				if (!PVI.imageStack[url]) {
					var w = e.data['wh']['w'], h = e.data['wh']['h'];

					if (PVI.cfg['svgsale'] === 1) {
						h = 400 / (w / h);
						w = 400;
					}
					else if (PVI.cfg['svgsale'] === 2) {
						h = (win.innerWidth / 2) / (w / h);
						w = win.innerWidth / 2;
					}
					else if (PVI.cfg['svgsale'] === 4) {
						h = win.screen.width / (w / h);
						w = win.screen.width;
					}

					PVI.imageStack[url] = [w, h];
				}

				if (PVI.PrevDIV.lastChild.nodeName == 'OBJECT') { PVI.PrevDIV.removeChild(PVI.PrevDIV.lastChild); }
				clearInterval(PVI.timers.imload);

				PVI.PrevDIV.firstChild.innerText = '';
				PVI.PrevDIV.firstChild.data = PVI.target.imagus_cache = url;
				PVI.show();
			}
			else if (e.data['cmd'] == 'reload') {
				PVI.init(true);
				PVI.init();
			}
		},
		init: function (deinit) {
			if (deinit && PVI.PrevDIV) {
				PVI.PrevDIV && root.removeChild(PVI.PrevDIV);
				PVI.PrevDIV = null;
				PVI.height_helper && root.removeChild(PVI.height_helper);
				PVI.height_helper = null;
				oex.removeEventListener('message', PVI.onMessage, false);
			}
			else {
				if (cfg['hz']) {
					PVI.cfg = JSON.parse(cfg['hz']);
				}
				else {
					PVI.cfg = {
						// anim
						'preload': false,
						'deactivate': 1,
						'act_trigger': 'shift',
						'placement': 0,
						'fade': 500,
						'sizing': 0,
						'position': 0,
						'follow': true,
						'move': true,
						'waitHide': true,
						'hideOnScroll': true,
						'zoomResized': 70,
						// style
						'outline': true,
						'background': 'cb',
						'margin': 10,
						'border': '5px solid rgba(255,255,255,.2);border-radius:5px',
						'shadow': '1px 1px 15px #000',
						// time
						'hoverTime': 500,
						'checkInterval': 400,
						'timeout': 5e3
					};
				}

				if (cfg['hz']) {
					for (var i in PVI.cfg) {
						if (/^\d+$/.test(PVI.cfg[i])) {
							PVI.cfg[i] = parseInt(PVI.cfg[i], 10);
						}
					}
				}

				if (PVI.cfg['caption']) { PVI.caption_helper = doc.createElement('SPAN'); }

				oex.addEventListener('message', PVI.onMessage, false);
			}

			win.opera[(deinit ? 'remove' : 'add') + 'EventListener']('BeforeEvent.mouseover', PVI.m_over, false);
			win.opera[(deinit ? 'remove' : 'add') + 'EventListener']('BeforeEvent.mouseout', PVI.hide, false);
			win.opera[(deinit ? 'remove' : 'add') + 'EventListener']('BeforeEvent.mousemove', PVI.m_move, false);
		}
	};

	PVI.init(false);
}
})(window, document);